﻿onClipEvent (load)
{
    function pushQualite()
    {
        if (_oldQualite != _parent._quality)
        {
            _oldQualite = _parent._quality;
            _level0.mcVariables7.sendQuality();
        } // end if
    } // End of the function
    function getHomeVariables()
    {
        trace ("getHomeVariables()");
        _maillotColors = new Array();
        _passeProbaTable1 = new Array();
        _passeProbaTable2 = new Array();
        _gameDuration = _level0.mcGameInterface.duree;
        _maillotColors[0] = _level0.mcGameInterface.couleur1;
        _maillotColors[1] = _level0.mcGameInterface.couleur2;
        _parent.mcField.decors.pub1 = _level0.mcGameInterface.pub1;
        _parent.mcField.decors.pub2 = _level0.mcGameInterface.pub2;
        _parent.mcInfo.gameMode = "Ready ?";
        _parent.mcInfo.version = _version;
        if (String(_level0.mcGameInterface.systempass).indexOf("attente") >= 0)
        {
            _bKeepBallTraj = 2;
        }
        else if (String(_level0.mcGameInterface.systempass).indexOf("libre") >= 0)
        {
            _bKeepBallTraj = 0;
        }
        else
        {
            _bKeepBallTraj = 1;
        } // end else if
        _powerQ = (_level0.mcGameInterface.shootcoef - 100) / 2100;
        if (_level0.mcGameInterface.bonus == 1)
        {
            _doBonus = true;
        }
        else
        {
            _doBonus = false;
        } // end else if
        _ctrlRange = _level0.mcGameInterface.ctrlrange * 10;
        if (_level0.mcGameInterface.ctrdisplay == "oui")
        {
            _btVisible = true;
        }
        else
        {
            _btVisible = false;
        } // end else if
        if (_level0.mcGameInterface.stopover == "oui")
        {
            _bStopOver = true;
        }
        else
        {
            _bStopOver = false;
        } // end else if
        _teamTable[0].goalSpeed = _level0.mcGameInterface.hgspeed;
        _teamTable[0].playerSpeed = _level0.mcGameInterface.hjspeed;
        _teamTable[0].passeSpeed = _level0.mcGameInterface.hpspeed;
        _passeProbaTable1[0] = 1;
        _passeProbaTable1[1] = 1;
        _teamTable[0].shootSpeed = _level0.mcGameInterface.hsspeed;
        _teamTable[0].tacleProba = (100 - _level0.mcGameInterface.htproba) / 100;
        _teamTable[0].boostDuration = _level0.mcGameInterface.hboostdelay;
        _teamTable[0].catchR1 = _level0.mcGameInterface.hgcatch;
        _teamTable[0].catchR2 = _level0.mcGameInterface.hgcatch2;
        _teamTable[0].catchRayon = _level0.mcGameInterface.hpcatch;
        if (_level0.mcGameInterface.hgboost == "oui")
        {
            _teamTable[0].goalCanBoost = true;
        }
        else
        {
            _teamTable[0].goalCanBoost = false;
        } // end else if
        _teamTable[1].goalSpeed = _level0.mcGameInterface.cpugspeed;
        _teamTable[1].playerSpeed = _level0.mcGameInterface.cpujspeed;
        _teamTable[1].passeSpeed = _level0.mcGameInterface.cpupspeed;
        _passeProbaTable2[0] = (100 - _level0.mcGameInterface.pproba) / 100;
        _passeProbaTable2[1] = 0.850000;
        _teamTable[1].shootSpeed = _level0.mcGameInterface.cpusspeed;
        _teamTable[1].tacleProba = (100 - _level0.mcGameInterface.cputproba) / 100;
        _teamTable[1].boostDuration = _level0.mcGameInterface.cpuboostdelay;
        _teamTable[1].catchR1 = _level0.mcGameInterface.cpugcatch;
        _teamTable[1].catchR2 = _level0.mcGameInterface.cpugcatch2;
        _teamTable[1].catchRayon = _level0.mcGameInterface.cpupcatch;
        if (_level0.mcGameInterface.cpugboost == "oui")
        {
            _teamTable[1].goalCanBoost = true;
        }
        else
        {
            _teamTable[1].goalCanBoost = false;
        } // end else if
        _teamTable[0].passeProba = _passeProbaTable1;
        _teamTable[1].passeProba = _passeProbaTable2;
    } // End of the function
    function Synchro()
    {
        var time;
        time = getTimer();
        _nbMs = time - _oldTime;
        if (_nbMs > 256)
        {
            _nbMs = 256;
            ++_frameOverflow;
        } // end if
        _oldTime = time;
        _parent.nbFrames = int(1000 / _nbMs);
        if (_debug == true)
        {
            this.debug1 = _state;
            this.debug2 = _arbitre.action;
            this.debug3 = _curFaute;
        } // end if
    } // End of the function
    function chronoReset()
    {
        _extraTime = 0;
        _chrono = _gameDuration * 1000 * 0.500000;
        _parent.mcPod.refreshTime(_chrono);
    } // End of the function
    function chronoManage()
    {
        if (_arbitre.action == "play")
        {
            _chrono = _chrono - _nbMs;
            _extraTime = _extraTime - _nbMs;
        } // end if
        if (_debug == true)
        {
            if (Key.isDown(81))
            {
                _chrono = 0;
                _extraTime = 0;
            } // end if
        } // end if
        if (_chrono <= 0)
        {
            _chrono = 0;
            if (_extraTime <= 0 && _leBallon.bToGoal == false)
            {
                _parent.mcPod.refreshTime(0);
                return (true);
            } // end if
        } // end if
        _parent.mcPod.refreshTime(_chrono);
        return (false);
    } // End of the function
    function pauseGame()
    {
        if (_state != "play")
        {
            return;
        } // end if
        _state = "pause";
        _parent.mcPause.interOn("pause", 1);
        _parent.mcSonStade.volumeSon(0, pan);
    } // End of the function
    function unpauseGame()
    {
        if (_state != "pause")
        {
            return;
        } // end if
        _state = "play";
        _parent.mcPause.interOff();
    } // End of the function
    function switchPause()
    {
        if (_state == "play")
        {
            pauseGame();
        }
        else if (_state == "pause")
        {
            unpauseGame();
        } // end else if
    } // End of the function
    function setCurMaillotColor(teamNum)
    {
        _maillotColor = _maillotColors[teamNum];
    } // End of the function
    function getCurMaillotColor()
    {
        return (_maillotColor);
    } // End of the function
    function arbitreCompteurShow()
    {
        _parent.mcCompteur._visible = true;
    } // End of the function
    function arbitreCompteurHide()
    {
        _parent.mcCompteur._visible = false;
    } // End of the function
    function arbitreCompteurRefresh()
    {
        _arbitre.waitShootTimer = _arbitre.waitShootTimer - _nbMs;
        if (_arbitre.waitShootTimer < 0)
        {
            _arbitre.waitShootTimer = 0;
        } // end if
        _parent.mcCompteur.compteur = int(_arbitre.waitShootTimer / 1000) + 1;
    } // End of the function
    function initArbitre()
    {
        _arbitre = new Object();
        _arbitre.timer = 0;
        _arbitre.action = "undef";
    } // End of the function
    function manageArbitre()
    {
        if (_arbitre.action == "faute")
        {
            if (_curFaute == "but")
            {
                _arbitre.timer = _arbitre.timer - _nbMs;
                if (_arbitre.timer < 0)
                {
                    _parent.mcCinematic.animeStop();
                    trigerMiseEnJeu(_goaledTeam, 500);
                    trigerReplay();
                } // end if
                return;
            } // end if
            if (_arbitre.nbMovingPlayers == 0)
            {
                _arbitre.timer = _arbitre.timer - _nbMs;
            } // end if
            if (_arbitre.timer < 0)
            {
                if (_curRelanceur >= 0 && _curRelanceur < 5 && _curFaute != "miseEnJeu")
                {
                    selectPlayer(_curRelanceur);
                    _parent.mcRay.showRay(_curRelanceur);
                } // end if
                _parent.mcInteruption.interOff();
                _arbitre.relanceDone = false;
                if (_curFaute != "miseEnJeu")
                {
                    _arbitre.waitShootTimer = 5000;
                    arbitreCompteurShow();
                }
                else
                {
                    _arbitre.waitShootTimer = 0;
                } // end else if
                _arbitre.action = "waitShoot";
                if (_sons == true)
                {
                    sonSifflet.start();
                } // end if
            } // end if
        }
        else if (_arbitre.action == "waitShoot")
        {
            arbitreCompteurRefresh();
            if (_curRelanceur >= 0)
            {
                if (_curRelanceur < 5)
                {
                    if (_arbitre.bRelanceAuto == true || _arbitre.waitShootTimer <= 0)
                    {
                        if (Math.random() > 0.950000 || _arbitre.waitShootTimer <= 0)
                        {
                            player = _players[_curReceveur];
                            ballPasse(player, _relanceSpeed, 0);
                            _arbitre.relanceDone = true;
                        } // end if
                    } // end if
                }
                else if (_curRelanceur >= 5)
                {
                    if (Math.random() > 0.950000 || _arbitre.waitShootTimer <= 0)
                    {
                        player = _players[_curReceveur];
                        ballPasse(player, _relanceSpeed, 0);
                        _arbitre.relanceDone = true;
                    } // end if
                } // end if
            } // end else if
            if (_arbitre.relanceDone == true)
            {
                _parent.mcRay.hideRay();
                _doFormation = false;
                _state = "play";
                _arbitre.action = "play";
                _curSendeur = _curRelanceur;
                _curSendeurFaute = _curRelanceur;
                _curRelanceur = -1;
                arbitreCompteurHide();
            } // end if
        } // end else if
    } // End of the function
    function initGame()
    {
        var i;
        var j;
        trace ("initGame()");
        _team1Side = 0;
        _parent.btStart._visible = false;
        _parent.mcInfo.btQuit._visible = true;
        arbitreCompteurHide();
        _catchRayon = 0;
        _x1Field = 75;
        _x2Field = 475;
        _y1Field = 10;
        _y2Field = 310;
        _dxField = _x2Field - _x1Field;
        _dyField = _y2Field - _y1Field;
        _xMField = (_x1Field + _x2Field) * 0.500000;
        _yMField = (_y1Field + _y2Field) * 0.500000;
        _y0Buts = 95;
        _y1Buts = _yMField - 41;
        _y2Buts = _yMField + 41;
        _y3Buts = 225;
        _players = new Array();
        _dispositions = new Array();
        _dispositionsTitles = new Array();
        _dispositionsTitles[0] = "";
        _dispositions[0] = [-120, -130, -100, -130, -80, -130, -60, -130, -40, -130];
        _dispositionsTitles[1] = "Remise en jeu";
        _dispositions[1] = [-180, 0, -110, -65, -110, 65, 0, -25, 0, 25];
        _dispositionsTitles[2] = "Remise en jeu";
        _dispositions[2] = [-180, 0, -110, -65, -110, 65, -40, -65, -40, 65];
        _dispositionsTitles[3] = "Corner";
        _dispositions[3] = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
        _dispositionsTitles[4] = "Touche";
        _dispositions[4] = [0, 0, 0, 0, 0, 0, 0, 0, 0, 0];
        _dispositionsTitles[5] = "Sortie de but";
        _dispositions[5] = [-180, 0, -110, -65, -110, 65, -40, -65, -40, 65];
        _dispositionsTitles[6] = "Mise en jeu";
        _dispositions[6] = [-180, 0, -110, -45, -110, 45, -40, -65, -40, 65];
        _dispositionsTitles[7] = "Mise en jeu";
        _dispositions[7] = [-180, 0, -100, 0, -40, 0, -30, -75, -30, 75];
        _dispositionsTitles[8] = "Mise en jeu";
        _dispositions[8] = [-180, 0, -110, -65, -110, 65, -100, 0, -40, 0];
        _dispositionsTitles[9] = "Mise en jeu";
        _dispositions[9] = [-180, 0, -120, -65, -120, 65, -40, -45, -40, 45];
        _teamTable = new Array();
        for (i = 0; i < 2; i++)
        {
            teamNode = new Object();
            teamNode.alertLevel = 0;
            teamNode.numTeam = i;
            teamNode.mode = "seek ball";
            teamNode.action = 0;
            teamNode.GoalStyle = 0;
            teamNode.nbDefencers = 0;
            _teamTable[i] = teamNode;
        } // end of for
        getHomeVariables();
        _ballDistances = [8, 8, 14, 0, 0, 14, 0, 14, 14, 8, 8, 8, 8];
        newPlayer(0, 0, _teamTable[0].goalSpeed);
        newPlayer(1, 0, _teamTable[0].playerSpeed);
        newPlayer(2, 0, _teamTable[0].playerSpeed);
        newPlayer(3, 0, _teamTable[0].playerSpeed);
        newPlayer(4, 0, _teamTable[0].playerSpeed);
        newPlayer(5, 1, _teamTable[1].goalSpeed);
        newPlayer(6, 1, _teamTable[1].playerSpeed);
        newPlayer(7, 1, _teamTable[1].playerSpeed);
        newPlayer(8, 1, _teamTable[1].playerSpeed);
        newPlayer(9, 1, _teamTable[1].playerSpeed);
        _bank = 0;
        _playerSortTable = new Array();
        for (i = 0; i < 10; i++)
        {
            _playerSortTable[i] = _players[i];
        } // end of for
    } // End of the function
    function refreshPods()
    {
        _parent.mcPod.refreshPod1(_teamTable[0].score);
        _parent.mcPod.refreshPod2(_teamTable[1].score);
    } // End of the function
    function initBonus()
    {
        if (_doBonus != true)
        {
            return;
        } // end if
        _bonusState = "wait";
        _bonusTimer = 5000;
        _parent.mcBonus._visible = false;
    } // End of the function
    function manageBonus()
    {
        if (_doBonus != true)
        {
            return;
        } // end if
        if (_bonusState == "done")
        {
            _bonusTimer = _bonusTimer - _nbMs;
            if (_bonusTimer <= 0)
            {
                _bonusState = "wait";
                _bonusTimer = 10000;
            } // end if
            return;
        } // end if
        if (_bonusState == "wait")
        {
            _bonusTimer = _bonusTimer - _nbMs;
            if (_bonusTimer <= 0 && _arbitre.action != "faute")
            {
                _bonusState = "on";
                _bonusTimer = 4000;
                _parent.mcBonus._visible = true;
                _xBonus = (Math.random() - 0.500000) * 300 + _xMField;
                _yBonus = (Math.random() - 0.500000) * 150 + _yMField;
                _parent.mcBonus._x = _xBonus;
                _parent.mcBonus._y = _yBonus;
                _parent.mcBonus.gotoAndPlay(1);
            } // end if
        } // end if
        if (_parent.mcBonus._visible == false)
        {
            return;
        } // end if
        if (_curPlayer < 0)
        {
            return;
        } // end if
        if (_arbitre.action == "faute")
        {
            endBonus();
            return;
        } // end if
        dx = _players[_curPlayer].x - _xBonus;
        dy = _players[_curPlayer].y - _yBonus;
        dt = dx * dx + dy * dy;
        if (dt < 900)
        {
            endBonus();
            if (_sons == true)
            {
                sonBonus.start(0, 99);
            } // end if
            _players[_curPlayer].godTimer = 7000;
            eval(_players[_curPlayer].clipName).mcGod._visible = true;
        } // end if
    } // End of the function
    function endBonus()
    {
        if (_doBonus != true)
        {
            return;
        } // end if
        _parent.mcBonus.gotoAndPlay(20);
        _bonusState = "done";
        _bonusTimer = 2000;
    } // End of the function
    function initRecord()
    {
        var i;
        _recordPtr = 0;
        _recordCurDepth = 0;
        _recordDepth = 50;
        _recordBallList = new Array();
        _recordPlayerList = new Array();
        _recordDecomp = new Array();
    } // End of the function
    function recordGame()
    {
        if (_curFaute == "but")
        {
            return;
        } // end if
        for (i = 0; i < 10; i++)
        {
            x = int((_players[i].x - 75) * 10);
            y = int((_players[i].y - 10) * 10);
            _recordPlayerList[(_recordPtr * 10 + i) * 3 + 0] = x;
            _recordPlayerList[(_recordPtr * 10 + i) * 3 + 1] = y;
            _recordPlayerList[(_recordPtr * 10 + i) * 3 + 2] = _players[i].oldFrame;
        } // end of for
        x = int((_leBallon.x - 75) * 10);
        y = int((_leBallon.y - 10) * 10);
        z = int(_leBallon.z * 100);
        _recordBallList[_recordPtr * 3 + 0] = x;
        _recordBallList[_recordPtr * 3 + 1] = y;
        _recordBallList[_recordPtr * 3 + 2] = z;
        ++_recordPtr;
        if (_recordPtr >= _recordDepth)
        {
            _recordPtr = 0;
        }
        else if (_recordCurDepth < _recordPtr)
        {
            _recordCurDepth = _recordPtr;
        } // end else if
    } // End of the function
    function trigerReplay()
    {
        _state = "replay";
        _repStartTime = getTimer();
        _parent.mcReplay.showIt();
    } // End of the function
    function trigerEndReplay()
    {
        _parent.mcReplay.hideIt();
        _state = "play";
        if (_curPorteur >= 0 && _curPorteur < 5)
        {
            for (i = 0; i < 5; i++)
            {
                if (i != _curPorteur)
                {
                    eval(_players[i].btName)._visible = true;
                } // end if
            } // end of for
        }
        else
        {
            for (i = 0; i < 10; i++)
            {
                eval(_players[i].btName)._visible = true;
            } // end of for
        } // end else if
    } // End of the function
    function manageReplay()
    {
        repTime = getTimer();
        repFrame = int((repTime - _repStartTime) / 100);
        if (repFrame >= _recordCurDepth)
        {
            trigerEndReplay();
            return;
        } // end if
        repFrame = repFrame + _recordPtr;
        if (repFrame >= _recordCurDepth)
        {
            repFrame = repFrame - _recordCurDepth;
        } // end if
        for (i = 0; i < 10; i++)
        {
            x = _recordPlayerList[(repFrame * 10 + i) * 3 + 0] / 10 + 75;
            y = _recordPlayerList[(repFrame * 10 + i) * 3 + 1] / 10 + 10;
            frame = _recordPlayerList[(repFrame * 10 + i) * 3 + 2];
            setProperty(eval(_players[i].clipName), _x, x);
            setProperty(eval(_players[i].clipName), _y, y);
            eval(_players[i].clipName).mcMaillot.gotoAndStop(frame);
            eval(_players[i].clipName).gotoAndStop(frame);
            eval(_players[i].clipName).mcBoost._visible = false;
            eval(_players[i].clipName).mcGod._visible = false;
            setProperty(eval(_players[i].btName), _visible, false);
        } // end of for
        if (_sons == true)
        {
            sonBonus.stop();
        } // end if
        x = _recordBallList[repFrame * 3 + 0] / 10 + 75;
        y = _recordBallList[repFrame * 3 + 1] / 10 + 10;
        z = _recordBallList[repFrame * 3 + 2] / 100;
        scale = (1000 + z * 30) / 10;
        setProperty(_parent.playersNode.ballon, _x, x);
        setProperty(_parent.playersNode.ballon, _y, y);
        setProperty(_parent.playersNode.ballon.ball, _xscale, scale);
        setProperty(_parent.playersNode.ballon.ball, _yscale, scale);
        setProperty(_parent.playersNode.ballon.ombre, _x, 2 + z * 0.800000);
        setProperty(_parent.playersNode.ballon.ombre, _y, 2 + z * 0.800000);
    } // End of the function
    function initSounds()
    {
        sonKick = new Sound(this);
        sonKick.attachSound("kick");
        sonSifflet = new Sound(this);
        sonSifflet.attachSound("sifflet");
        sonAccelerate = new Sound(this);
        sonAccelerate.attachSound("accelerate");
        sonBuzzer = new Sound(this);
        sonBuzzer.attachSound("buzzer");
        sonBonus = new Sound(this);
        sonBonus.attachSound("bonus");
        sonHourra = new Sound(this);
        sonHourra.attachSound("hourra");
        sonTacle = new Sound(this);
        sonTacle.attachSound("tacle");
        sonPoteau = new Sound(this);
        sonPoteau.attachSound("idPoteau");
        sonFx1 = new Sound(this);
        sonFx1.attachSound("fx1");
    } // End of the function
    function switchSonOn()
    {
        _sons = true;
        _parent.mcInfo.btSon.gotoAndStop(1);
        _parent.mcSonStade.switchOn();
    } // End of the function
    function switchSonOff()
    {
        _sons = false;
        _parent.mcInfo.btSon.gotoAndStop(2);
        _parent.mcSonStade.switchOff();
    } // End of the function
    function switchSelMode1()
    {
        _bAutoSelection = true;
        _parent.mcInfo.btMS.gotoAndStop(2);
    } // End of the function
    function switchSelMode2()
    {
        _bAutoSelection = false;
        _parent.mcInfo.btMS.gotoAndStop(1);
    } // End of the function
    function manageSonStade()
    {
        dx = _leBallon.x - _xMField;
        if (dx < 0)
        {
            pan = 0;
        }
        else
        {
            pan = 1;
        } // end else if
        if (_curSendeur < 5 && _curPorteur != 0 && pan != _team1Side && _arbitre.action == "play")
        {
            dx = int(Math.abs(dx) - 70);
            if (dx < 0)
            {
                dx = 0;
            }
            else if (dx > 100)
            {
                dx = 100;
            } // end else if
            _parent.mcSonStade.volumeSon(dx, pan);
        }
        else
        {
            _parent.mcSonStade.volumeSon(0, pan);
        } // end else if
    } // End of the function
    function inRange(x1, y1, x2, y2, range)
    {
        var dx;
        var dy;
        var distance;
        dx = Math.abs(x2 - x1);
        if (range < dx)
        {
            return (false);
        } // end if
        dy = Math.abs(y2 - y1);
        if (range < dy)
        {
            return (false);
        } // end if
        distance = dx * dx + dy * dy;
        if (range * range < distance)
        {
            return (false);
        } // end if
        return (true);
    } // End of the function
    function initBall()
    {
        var i;
        var j;
        _leBallon = new Object();
        _leBallon.onTop = false;
        _leBallon.bToGoal = false;
        _leBallon.passeCmpt = 0;
        ballPut(275, 150);
        _parent.playersNode.attachMovie("idBallon", "ballon", 0);
        setProperty(_parent.playersNode.ballon, _visible, true);
        setProperty(_parent.playersNode.ballon, _x, 0);
        setProperty(_parent.playersNode.ballon, _y, 0);
        _parent.playersNode.ballon.ball.gotoAndStop(1);
        _clocheTable = new Array();
        for (j = 0; j < 360; j++)
        {
            leSinus = Math.sin(j * 0.500000 * 3.141593 / 180);
            _clocheTable[j] = leSinus * 100;
        } // end of for
        for (j = 0; j < 90; j++)
        {
            leSinus = Math.sin(j * 2 * 3.141593 / 180);
            _clocheTable[360 + j] = leSinus * 30;
        } // end of for
    } // End of the function
    function ballPut(x, y)
    {
        _leBallon.x = x;
        _leBallon.y = y;
        _leBallon.xOld = x;
        _leBallon.yOld = y;
        _leBallon.z = 0;
        impulseBall(0, 0);
    } // End of the function
    function impulseBall(angle, baseSpeed)
    {
        trace ("base speed" + baseSpeed);
        frame = int((baseSpeed - 100) * 0.400000);
        if (frame < 1)
        {
            frame = 1;
        } // end if
        _parent.playersNode.ballon.ball.gotoAndStop(frame);
        _leBallon.bCloche = 0;
        _leBallon.clocheScale = 0;
        _leBallon.clochePtrSpeed = 0;
        _leBallon.nx = Math.sin(angle);
        _leBallon.ny = -Math.cos(angle);
        _leBallon.vx = _leBallon.nx * baseSpeed;
        _leBallon.vy = _leBallon.ny * baseSpeed;
        _leBallon.speed = baseSpeed;
        ballNewPorteur(-1);
        if (_leBallon.bToGoal == true)
        {
            setProperty(_parent.playersNode.ballon.trainee, _visible, true);
            setProperty(_parent.playersNode.ballon.trainee, _rotation, angle * 57.295780);
        } // end if
    } // End of the function
    function completeImpulse1(distance)
    {
        _leBallon.bCloche = 0;
        _leBallon.clochePtr = 0;
        tmp = distance - 20;
        if (tmp < 0)
        {
            tmp = 0;
        } // end if
        _leBallon.clocheScale = tmp * 0.003000;
        _leBallon.clochePtrSpeed = 43 / distance * (_leBallon.speed / 120);
    } // End of the function
    function completeImpulse2(distance)
    {
        _leBallon.bCloche = 1;
        _leBallon.cfz = distance * 0.000020 * (_leBallon.speed / 90);
    } // End of the function
    function completeImpulse3(distance)
    {
        _leBallon.bCloche = 0;
        _leBallon.clochePtr = 0;
        _leBallon.clocheScale = 0.600000;
        _leBallon.clochePtrSpeed = 43 / distance * (_leBallon.speed / 120);
    } // End of the function
    function manageBall1()
    {
        var i;
        var dt;
        var dx;
        var dy;
        var ptr;
        var speed;
        var nbRec;
        var angle;
        var player;
        var action;
        _leBallon.xOld = _leBallon.x;
        _leBallon.yOld = _leBallon.y;
        if (_curPorteur < 0)
        {
            if (_leBallon.bCloche == 1)
            {
                _leBallon.z = _leBallon.z + _leBallon.cfz * _nbMs;
                if (_leBallon.z <= 0)
                {
                    _leBallon.bCloche = 0;
                } // end if
            }
            else
            {
                _leBallon.clochePtr = _leBallon.clochePtr + _leBallon.clochePtrSpeed * _nbMs;
                if (_leBallon.clochePtr >= 450)
                {
                    _leBallon.z = 0;
                }
                else
                {
                    ptr = int(_leBallon.clochePtr);
                    _leBallon.z = _clocheTable[ptr] * _leBallon.clocheScale;
                } // end else if
            } // end else if
            if (_leBallon.z <= 0.100000)
            {
                nbSteps = int(_nbMs / 16);
                if (nbSteps < 1)
                {
                    nbSteps = 1;
                }
                else if (nbSteps > 8)
                {
                    nbSteps = 8;
                } // end else if
                dt = _nbMs / nbSteps;
                for (i = 0; i < nbSteps; i++)
                {
                    dx = _leBallon.vx * 0.001000 * dt;
                    dy = _leBallon.vy * 0.001000 * dt;
                    _leBallon.vx = _leBallon.vx - _leBallon.vx * 0.001000 * dt;
                    _leBallon.vy = _leBallon.vy - _leBallon.vy * 0.001000 * dt;
                    _leBallon.x = _leBallon.x + dx;
                    _leBallon.y = _leBallon.y + dy;
                } // end of for
            }
            else
            {
                dx = _leBallon.vx * _nbMs * 0.001000;
                dy = _leBallon.vy * _nbMs * 0.001000;
                _leBallon.x = _leBallon.x + dx;
                _leBallon.y = _leBallon.y + dy;
            } // end else if
            _leBallon.distDone = Math.sqrt(dx * dx + dy * dy);
            speed = Math.sqrt(_leBallon.vx * _leBallon.vx + _leBallon.vy * _leBallon.vy);
            if (speed < 1)
            {
                ++_leBallon.passeCmpt;
                _leBallon.bToGoal = false;
                setProperty(_parent.playersNode.ballon.trainee, _visible, false);
            } // end if
            if (_state == "play" && _curRelanceur < 0 && _arbitre.action != "faute")
            {
                CatchBall();
            } // end if
        } // end if
        if (_leBallon.z < 15)
        {
            if (_leBallon.onTop != false)
            {
                _leBallon.onTop = false;
                _parent.playersNode.ballon.swapDepths(0);
            } // end if
        }
        else if (_leBallon.onTop != true)
        {
            _leBallon.onTop = true;
            _parent.playersNode.ballon.swapDepths(255);
        } // end else if
        if (_leBallon.x < _xMField)
        {
            _leBallon.side = 0;
        }
        else
        {
            _leBallon.side = 1;
        } // end else if
    } // End of the function
    function manageBall2()
    {
        var scale;
        if (_curPorteur >= 0)
        {
            player = _players[_curPorteur];
            angle = player.angleBallon;
            action = player.action;
            _leBallon.vx = Math.sin(angle);
            _leBallon.vy = -Math.cos(angle);
            _leBallon.x = player.x + _ballDistances[action] * _leBallon.vx;
            _leBallon.y = player.y + _ballDistances[action] * _leBallon.vy;
            if (_leBallon.z > 0)
            {
                _leBallon.z = _leBallon.z - _nbMs * 0.100000;
                if (_leBallon.z < 0)
                {
                    _leBallon.z = 0;
                } // end if
            } // end if
        } // end if
        if (_state == "play" && _arbitre.action == "play")
        {
            ballCheckZones();
        } // end if
        scale = (1000 + _leBallon.z * 30) / 10;
        setProperty(_parent.playersNode.ballon, _x, _leBallon.x);
        setProperty(_parent.playersNode.ballon, _y, _leBallon.y);
        setProperty(_parent.playersNode.ballon.ball, _xscale, scale);
        setProperty(_parent.playersNode.ballon.ball, _yscale, scale);
        setProperty(_parent.playersNode.ballon.ombre, _x, 2 + _leBallon.z * 0.800000);
        setProperty(_parent.playersNode.ballon.ombre, _y, 2 + _leBallon.z * 0.800000);
    } // End of the function
    function CatchBall()
    {
        var i;
        var dx;
        var dy;
        var nx2;
        var ny2;
        var dist;
        var projX;
        var projY;
        var player;
        var best;
        var leCos;
        var rayon;
        var zlimit;
        var bestDist;
        var distance;
        if (_sentTimer >= 0)
        {
            _sentTimer = _sentTimer - _nbMs;
        } // end if
        best = -1;
        for (i = 0; i < 10; i++)
        {
            player = _players[i];
            if (_teamTable[0].mode == "seek ball")
            {
                rayon = 11;
            }
            else
            {
                rayon = player.catchRayon;
            } // end else if
            zlimit = 15;
            if (_leBallon.bToGoal == true)
            {
                if (i % 5 == 0)
                {
                    rayon = _catchRayon;
                    zlimit = 30;
                } // end if
            } // end if
            if (_leBallon.z >= zlimit)
            {
                continue;
            } // end if
            if (i == _curSendeur && _sentTimer >= 0)
            {
                continue;
            } // end if
            nx2 = player.x - _leBallon.xOld;
            ny2 = player.y - _leBallon.yOld;
            dist = Math.sqrt(nx2 * nx2 + ny2 * ny2);
            if (dist < rayon)
            {
                best = i;
                break;
            } // end if
            leCos = _leBallon.nx * nx2 + _leBallon.ny * ny2;
            if (leCos < -rayon || _leBallon.distDone + rayon < leCos)
            {
                continue;
            } // end if
            projX = _leBallon.xOld + leCos * _leBallon.nx;
            projY = _leBallon.yOld + leCos * _leBallon.ny;
            dx = player.x - projX;
            dy = player.y - projY;
            distance = Math.sqrt(dx * dx + dy * dy);
            if (rayon < distance)
            {
                continue;
            } // end if
            if (best < 0 || leCos < bestDist)
            {
                best = i;
                bestDist = leCos;
            } // end if
        } // end of for
        if (best < 0)
        {
            return (false);
        } // end if
        if (best % 5 == 0 && _leBallon.bToGoal == true)
        {
            if (_probaBlocShoot < Math.random())
            {
                _bReprise = false;
                setProperty(_parent.playersNode.ballon.trainee, _visible, false);
                _leBallon.bToGoal = false;
                _leBallon.x = _leBallon.xOld - _leBallon.nx * 5;
                _leBallon.y = _leBallon.yOld - _leBallon.ny * 5;
                dist = 50 + Math.random() * 20;
                x2 = _leBallon.x - _leBallon.nx * dist;
                y2 = _leBallon.y + _leBallon.ny * dist;
                speed = _leBallon.speed * 0.700000;
                if (speed > 30)
                {
                    speed = 30;
                } // end if
                ballShoot(null, x2, y2, speed, 1);
                return (false);
            } // end if
        }
        else if (_bReprise == true && best < 5)
        {
            ballNewPorteur(best);
            _probaBlocShoot = 0;
            player = _players[best];
            player.pause = false;
            ballShootGoal(player, _bRepriseX, _bRepriseY, _teamTable[0].shootSpeed);
            dx = player.x - _bRepriseX;
            dy = player.y - _bRepriseY;
            dist = dx * dx + dy * dy;
            if (dist < 5625)
            {
                playerFx1(player, 1);
            }
            else
            {
                playerFx1(player, 0);
            } // end else if
            _butPlayer = -1;
            return (false);
        } // end else if
        ballNewPorteur(best);
        return (true);
    } // End of the function
    function ballNewPorteur(porteur)
    {
        _butPlayer = -1;
        _passeTargetId = -1;
        _leBallon.passeCmpt = _leBallon.passeCmpt + 1 & 4095;
        if (_curPorteur >= 5)
        {
            setProperty(eval(_players[_curPorteur].btName), _visible, false);
        }
        else if (_curPorteur >= 0)
        {
            setProperty(eval(_players[_curPorteur].btName), _visible, true);
            eval(_players[_curPorteur].clipName).mcBoost._visible = false;
        } // end else if
        if (porteur >= 0)
        {
            _bReprise = false;
            _leBallon.bToGoal = false;
            setProperty(_parent.playersNode.ballon.trainee, _visible, false);
            _curPorteur = porteur;
            _curSendeur = _curPorteur;
            _curSendeurFaute = _curPorteur;
            _players[_curPorteur].possession = 0;
            if (_curPorteur >= 5)
            {
                eval(_players[_curPorteur].btName)._visible = true;
            }
            else
            {
                selectPlayer(_curPorteur);
                eval(_players[_curPorteur].btName)._visible = false;
            } // end else if
            _players[_curPorteur].nbBoost = 5;
            if (_curPorteur > 1 && _curPorteur < 5)
            {
                eval(_players[_curPorteur].clipName).mcBoost.gotoAndStop(6);
                eval(_players[_curPorteur].clipName).mcBoost._visible = true;
            } // end if
            tacticRefreshAi();
            _parent.playersNode.ballon.ball.gotoAndStop(1);
        }
        else
        {
            _curPorteur = -1;
        } // end else if
    } // End of the function
    function ballPasse(player2, speed, clocheLevel)
    {
        ballShoot(null, player2.x, player2.y, speed, clocheLevel);
        player2.ballPasseId = _leBallon.passeCmpt;
        _passeTargetId = player2.id;
    } // End of the function
    function ballShootGoal(player, x2, y2, speed)
    {
        var teamNum;
        teamNum = player.teamNum;
        _teamTable[teamNum].statTirs = _teamTable[teamNum].statTirs + 1;
        teamNum = teamNum ^ 1;
        _leBallon.bToGoal = true;
        ballShoot(player, x2, y2, speed, 2);
        if (teamNum != _handicapedTeam)
        {
            _goalCanBoost = _teamTable[teamNum].goalCanBoost;
            _catchRayon = _teamTable[teamNum].catchR1 + Math.random() * 6;
        }
        else
        {
            _goalCanBoost = false;
            _catchRayon = _teamTable[teamNum].catchR2;
        } // end else if
        _xGoalTarget = x2 - _leBallon.nx * 35;
        _yGoalTarget = y2 - _leBallon.ny * 35;
    } // End of the function
    function ballShoot(player, x2, y2, speed, clocheLevel)
    {
        var dx;
        var dy;
        var angle;
        var distance;
        if (_sons == true)
        {
            if (_leBallon.bToGoal == true)
            {
                sonKick.start();
            }
            else
            {
                sonKick.start();
            } // end if
        } // end else if
        ++_leBallon.passeCmpt;
        _sentTimer = 600;
        dx = x2 - _leBallon.x;
        dy = y2 - _leBallon.y;
        distance = Math.sqrt(dx * dx + dy * dy);
        if (distance > 0.000010)
        {
            dx = dx / distance;
            dy = dy / distance;
            angle = Math.atan2(dx, -dy);
        }
        else
        {
            angle = player.angleBallon;
        } // end else if
        if (clocheLevel == 2)
        {
            speed = speed + distance * 0.012500;
        } // end if
        impulseBall(angle, speed);
        if (clocheLevel == 0)
        {
            completeImpulse1(distance);
        }
        else if (clocheLevel == 1)
        {
            completeImpulse3(distance);
        }
        else
        {
            completeImpulse2(distance);
        } // end else if
    } // End of the function
    function ballCheckZones()
    {
        if (_leBallon.y < _y1Field)
        {
            trigerTouche(_curSendeurFaute, 0);
        } // end if
        if (_y2Field < _leBallon.y)
        {
            trigerTouche(_curSendeurFaute, 1);
        } // end if
        if (_leBallon.vx <= 0)
        {
            if (_x1Field >= _leBallon.x)
            {
                trigerSortie(_x1Field, 0);
            } // end if
        } // end if
        if (_leBallon.vx >= 0)
        {
            if (_leBallon.x >= _x2Field)
            {
                trigerSortie(_x2Field, 1);
            } // end if
        } // end if
    } // End of the function
    function trigerSortie(xCol, side)
    {
        var team;
        dx = _leBallon.x - _leBallon.xOld;
        dy = _leBallon.y - _leBallon.yOld;
        taille = Math.sqrt(dx * dx + dy * dy);
        Q = (xCol - _leBallon.xOld) / taille;
        yCol = _leBallon.yOld + Q * dy;
        if (_curPorteur < 0)
        {
            dy1 = Math.abs(yCol - _y1Buts);
            dy2 = Math.abs(yCol - _y2Buts);
            if (dy1 <= 10 || dy2 <= 10)
            {
                _leBallon.x = xCol;
                _leBallon.y = yCol;
                _leBallon.vx = -_leBallon.vx * 0.500000;
                _leBallon.vy = _leBallon.vy * 0.500000;
                _leBallon.cfz = -_leBallon.cfz * 2;
                setProperty(_parent.playersNode.ballon.trainee, _visible, false);
                if (_sons == true)
                {
                    sonPoteau.start();
                } // end if
                return;
            } // end if
        } // end if
        if (side == _team1Side)
        {
            team = 0;
        }
        else
        {
            team = 1;
        } // end else if
        if (yCol < _y1Buts)
        {
            if (_players[_curSendeurFaute].teamNum == team)
            {
                trigerCorner(side, 0);
            }
            else
            {
                trigerRelanceGoal(side);
            } // end else if
            return;
        } // end if
        if (_y2Buts < yCol)
        {
            if (_players[_curSendeurFaute].teamNum == team)
            {
                trigerCorner(side, 1);
            }
            else
            {
                trigerRelanceGoal(side);
            } // end else if
            return;
        } // end if
        trigerGoal(side);
    } // End of the function
    function initAI()
    {
        var i;
        var pos;
        var node;
        var teamNode;
        var passeNode;
        _comportTable = new Array();
        _comportTable[0] = ["G_keepBut", "P_defend_GoalUp", "P_defend_GoalDwn", "P_seekBall", "P_seekBall"];
        _comportTable[1] = ["G_keepBut", "P_defend_GoalUp", "P_defend_GoalDwn", "P_seekBall", "P_seekBall"];
        _comportTable[2] = ["G_keepBut", "P_defend_GoalUp", "P_defend_GoalDwn", "P_seekBall", "P_seekBall"];
        _comportTable[3] = ["G_waitBut", "P_attaque_PosDefenceUp", "P_attaque_PosDefenceDwn", "P_attaque_BackUp", "P_attaque_BackUp"];
        _comportTable[4] = ["G_waitBut", "P_attaque_PosDefenceUp", "P_attaque_BackUp", "P_attaque_BackUp", "P_attaque_BackUp"];
        _comportTable[5] = ["G_waitBut", "P_attaque_PosDefenceUp", "P_attaque_PosDefenceDwn", "P_attaque_BackUp", "P_attaque_PosDefenceDwn"];
        _comportTable[6] = ["G_keepBut", "P_defend_GoalUp", "P_defend_GoalDwn", "P_defend_Catch", "P_defend_marquage"];
        _comportTable[7] = ["G_keepBut", "P_defend_GoalUp", "P_defend_GoalDwn", "P_defend_Catch", "P_defend_marquage"];
        _comportTable[8] = ["G_keepBut", "P_defend_GoalUp", "P_defend_GoalDwn", "P_defend_Catch", "P_defend_marquage"];
        _comportTable[9] = ["G_keepBut", "P_posRelanceAdv", "P_posRelanceAdv", "P_posRelanceAdv", "P_posRelanceAdv"];
        _comportTable[10] = ["G_keepBut", "P_posRelanceAdv", "P_posRelanceAdv", "P_posRelanceAdv", "P_posRelanceAdv"];
        _comportTable[11] = ["G_keepBut", "P_posRelanceAdv", "P_posRelanceAdv", "P_posRelanceAdv", "P_posRelanceAdv"];
        _comportTable[12] = ["G_waitBut", "P_posRelanceFrd", "P_posRelanceFrd", "P_posRelanceFrd", "P_posRelanceFrd"];
        _comportTable[13] = ["G_waitBut", "P_posRelanceFrd", "P_posRelanceFrd", "P_posRelanceFrd", "P_posRelanceFrd"];
        _comportTable[14] = ["G_waitBut", "P_posRelanceFrd", "P_posRelanceFrd", "P_posRelanceFrd", "P_posRelanceFrd"];
        _comportTable[15] = ["G_keepBut", "P_stop", "P_stop", "P_stop", "P_stop"];
        _comportTable[16] = ["G_keepBut", "P_stop", "P_stop", "P_stop", "P_stop"];
        _comportTable[17] = ["G_keepBut", "P_stop", "P_stop", "P_stop", "P_stop"];
        _attaqueFlags = new Array();
        _playerPasseTable = new Array();
        for (i = 0; i < 10; i++)
        {
            passeNode = new Object();
            passeNode.angle = 0;
            passeNode.norme = 0;
            _playerPasseTable[i] = passeNode;
        } // end of for
        _sortedList1 = new Array();
        _sortedList2 = new Array();
        for (i = 0; i < 5; i++)
        {
            node = new Object();
            node.dist = 0;
            node.player = i;
            _sortedList1[i] = node;
            node = new Object();
            node.dist = 0;
            node.player = i + 5;
            _sortedList2[i] = node;
        } // end of for
        _teamTable[0].sortedList1 = _sortedList1;
        _teamTable[0].sortedList2 = _sortedList2;
        _teamTable[1].sortedList1 = _sortedList2;
        _teamTable[1].sortedList2 = _sortedList1;
        _sortedList1[0].player = 0;
        _sortedList2[0].player = 5;
        _sortedList1[1].player = 1;
        _sortedList1[2].player = 2;
        _sortedList2[1].player = 6;
        _sortedList2[2].player = 7;
    } // End of the function
    function newSeedAi()
    {
        var i;
        trace ("team1 " + _team1Form);
        _parent.mcInfo.gameMode = _teamFormTable[_team1Form];
        _teamTable[0].form = _team1Form;
        _teamTable[1].form = 0;
        if (_team1Side == 0)
        {
            _teamTable[0].side = 0;
            _teamTable[0].signeDir = 1;
        }
        else
        {
            _teamTable[0].side = 1;
            _teamTable[0].signeDir = -1;
        } // end else if
        _teamTable[1].side = _teamTable[0].side ^ 1;
        _teamTable[1].signeDir = -_teamTable[0].signeDir;
        for (i = 0; i < 2; i++)
        {
            for (j = 0; j < 5; j++)
            {
                _players[i * 5 + j].xBase = _xMField + (_dispositions[6 + _teamTable[i].form][j * 2 + 0] + (Math.random() - 0.500000) * 15) * _teamTable[i].signeDir;
                _players[i * 5 + j].yBase = _yMField + (_dispositions[6 + _teamTable[i].form][j * 2 + 1] + (Math.random() - 0.500000) * 15);
            } // end of for
        } // end of for
    } // End of the function
    function tacticRefreshAi()
    {
        var i;
        var j;
        var dx;
        var dy;
        var dist;
        var index;
        var reference;
        var teamNode;
        _aiRefreshTimer = 2000;
        if (_curPorteur >= 0)
        {
            reference = _curPorteur;
        }
        else if (_sentTimer > 0)
        {
            reference = _curSendeur;
        }
        else
        {
            reference = -1;
        } // end else if
        if (reference >= 0 && reference < 5)
        {
            _teamTable[0].mode = "goto goal";
            _teamTable[1].mode = "defend-seek ball";
            _bShootDirect = false;
        }
        else if (reference >= 5)
        {
            _teamTable[0].mode = "defend-seek ball";
            _teamTable[1].mode = "goto goal";
        }
        else
        {
            _bShootDirect = false;
            _teamTable[0].mode = "seek ball";
            _teamTable[1].mode = "seek ball";
        } // end else if
        if (_players[3].ballDist < _players[4].ballDist)
        {
            sens = 0;
        }
        else
        {
            sens = 1;
        } // end else if
        _sortedList1[3].player = 3 + sens;
        _sortedList1[4].player = 3 + (sens ^ 1);
        if (_players[8].ballDist < _players[9].ballDist)
        {
            sens = 0;
        }
        else
        {
            sens = 0;
        } // end else if
        _sortedList1[8].player = 8 + sens;
        _sortedList1[9].player = 9 + (sens ^ 1);
        _curMarquage = -1;
        for (i = 0; i < 2; i++)
        {
            teamNode = _teamTable[i];
            if (teamNode.mode == "seek ball")
            {
                fillPlayerComportements(0, teamNode);
            }
            else if (teamNode.mode == "goto goal")
            {
                if (reference % 5 == 0 && _curPorteur >= 0)
                {
                    fillPlayerComportements(4, teamNode);
                }
                else
                {
                    fillPlayerComportements(1, teamNode);
                } // end else if
            }
            else if (teamNode.mode == "defend-seek ball")
            {
                if (reference % 5 == 0 && _curPorteur >= 0)
                {
                    fillPlayerComportements(3, teamNode);
                }
                else
                {
                    fillPlayerComportements(2, teamNode);
                } // end else if
            } // end else if
            if (_debug == true)
            {
                for (j = 0; j < 5; j++)
                {
                    set("this.debug" + (4 + j), _players[j].comportement);
                } // end of for
            } // end if
        } // end of for
    } // End of the function
    function fillPlayerComportements(compId, teamNode)
    {
        var i;
        var curComport;
        var playerIndex;
        compId = compId * 3 + teamNode.form;
        for (i = 0; i < 5; i++)
        {
            playerIndex = teamNode.sortedList1[i].player;
            curComport = _comportTable[compId][i];
            if (playerIndex == _curPlayer)
            {
                curComport = "playerControlled";
            }
            else if (playerIndex == _curSendeur && playerIndex > 5)
            {
                curComport = "cpuControlled";
            } // end else if
            if (curComport == "P_attaque_BackUp")
            {
                if (_curMarquage < 0)
                {
                    _curMarquage = playerIndex;
                } // end if
            } // end if
            if (_players[playerIndex].comportement != curComport)
            {
                _players[playerIndex].comportementFirstFrame = true;
                _players[playerIndex].comportement = curComport;
                _players[playerIndex].comportementParam = -1;
            } // end if
        } // end of for
    } // End of the function
    function computeTeamAlerteLevel(teamNum, teamSide)
    {
        var level;
        var teamNode;
        teamNode = _teamTable[teamNum];
        if (_leBallon.side != teamSide)
        {
            level = 0;
            dx = Math.abs(_leBallon.x - (_xMField + _dxField * teamNode.signeDir * 0.500000));
            if (dx < 100)
            {
                probaId = 0;
            }
            else
            {
                probaId = 1;
            } // end else if
        }
        else
        {
            level = 1;
            probaId = 1;
        } // end else if
        teamNode.curPasseProba = teamNode.passeProba[probaId];
        if (level == 1)
        {
            dx = Math.abs(_leBallon.x - (_xMField - _dxField * teamNode.signeDir * 0.500000));
            dy = Math.abs(_leBallon.y - _yMField);
            if (dx < 70 && dy < 60)
            {
                level = 2;
            } // end if
        } // end if
        if (teamNode.alertLevel != level)
        {
            _aiRefreshTimer = 0;
            teamNode.alertLevel = level;
            if (level == 2)
            {
                teamNode.GoalStyle = int(Math.random() * 2);
                teamNode.GoalStyle = teamNode.GoalStyle & 1;
            } // end if
        } // end if
        if (_debug == true)
        {
            if (teamNum == 0)
            {
                _parent.aiDebug0.alert1 = level;
            }
            else
            {
                _parent.aiDebug0.alert2 = level;
            } // end if
        } // end else if
    } // End of the function
    function manageAi()
    {
        var i;
        var j;
        var dx;
        var dy;
        var player;
        var distance;
        if (_doFormation != false)
        {
            if (_curFaute == "but")
            {
                managePlayersWon(_goaledTeam ^ 1);
                managePlayersLost(_goaledTeam);
            } // end if
            return;
        } // end if
        if (_curSendeur >= 0)
        {
            if (_curSendeur < 5)
            {
                _teamTable[0].statPossession = _teamTable[0].statPossession + _nbMs;
            }
            else
            {
                _teamTable[1].statPossession = _teamTable[1].statPossession + _nbMs;
            } // end if
        } // end else if
        computeTeamAlerteLevel(0, _team1Side);
        computeTeamAlerteLevel(1, _team1Side ^ 1);
        for (i = 0; i < 10; i++)
        {
            player = _players[i];
            if (i % 5 != 0)
            {
                probaTimer = player.probaTimer + _nbMs;
                nbTacles = int(probaTimer / _probaTimerLimit);
                probaTimer = probaTimer - _probaTimerLimit * nbTacles;
                player.probaTimer = probaTimer;
                player.nbProbsCheck = nbTacles;
            } // end if
            dx = player.x - player.xTarget;
            dy = player.y - player.yTarget;
            distance = dx * dx + dy * dy;
            player.distToDo = distance;
            dx = player.x - _leBallon.x;
            dy = player.y - _leBallon.y;
            distance = dx * dx + dy * dy;
            player.ballDist = distance;
        } // end of for
        _aiRefreshTimer = _aiRefreshTimer - _nbMs;
        if (_aiRefreshTimer <= 0)
        {
            tacticRefreshAi();
        } // end if
        if (_curPorteur >= 5)
        {
            teamAttaqueFlagsCompute(_teamTable[1]);
        }
        else if (_curPorteur >= 0)
        {
            teamAttaqueFlagsCompute(_teamTable[0]);
        } // end else if
        manageTeamAi(0);
        manageTeamAi(1);
    } // End of the function
    function manageTeamAi(teamNum)
    {
        var i;
        var index;
        var player;
        var mode;
        var teamNode;
        var comportement;
        teamNode = _teamTable[teamNum];
        mode = teamNode.mode;
        index = teamNum * 5;
        for (i = index; i < index + 5; i++)
        {
            player = _players[i];
            if (player.ballPasseId == _leBallon.passeCmpt && i != _curPlayer)
            {
                dx = Math.abs(player.x - _leBallon.x);
                dy = Math.abs(player.y - _leBallon.y);
                if (dx < 25 && dy < 25)
                {
                    player.xTarget = _leBallon.x;
                    player.yTarget = _leBallon.y;
                }
                else
                {
                    player.xTarget = player.x;
                    player.yTarget = player.y;
                } // end else if
                continue;
            } // end if
            comportement = player.comportement;
            if (comportement == "playerControlled")
            {
                mainHumanControl(i, player, teamNode);
                continue;
            } // end if
            if (comportement == "cpuControlled")
            {
                mainCpuControl(i, player, teamNode);
                continue;
            } // end if
            if (comportement == "G_seekBall")
            {
                goalAI_seekBall(i, player, teamNode);
                continue;
            } // end if
            if (comportement == "G_waitBut")
            {
                goalAI_waitBut(i, player, teamNode);
                continue;
            } // end if
            if (comportement == "G_keepBut")
            {
                goalAI_keepBut(i, player, teamNode);
                continue;
            } // end if
            if (comportement == "P_attaque_BackUp")
            {
                joueurAI_attaqueBackUp(player, teamNode);
                continue;
            } // end if
            if (comportement == "P_attaque_PosDefenceUp")
            {
                joueurAI_attaquePlacementDefence(player, teamNode);
                continue;
            } // end if
            if (comportement == "P_attaque_PosDefenceDwn")
            {
                joueurAI_attaquePlacementDefence(player, teamNode);
                continue;
            } // end if
            if (comportement == "P_defend_Catch")
            {
                joueurAI_defendCatch(player, teamNode);
                continue;
            } // end if
            if (comportement == "P_defend_marquage")
            {
                joueurAI_defendMarquage(player, teamNode);
                continue;
            } // end if
            if (comportement == "P_defend_GoalUp")
            {
                joueurAI_defendGoal(player, teamNode, 0);
                continue;
            } // end if
            if (comportement == "P_defend_GoalDwn")
            {
                joueurAI_defendGoal(player, teamNode, 1);
                continue;
            } // end if
            if (comportement == "P_posRelanceAdv")
            {
                joueurAI_relanceAdv(player, teamNode);
                continue;
            } // end if
            if (comportement == "P_posRelanceFrd")
            {
                joueurAI_relanceFrd(player, teamNode);
                continue;
            } // end if
            if (comportement == "P_seekBall")
            {
                joueurAI_seekBall(player, teamNode);
                continue;
            } // end if
            if (comportement == "P_stop")
            {
                player.xTarget = player.x;
                player.yTarget = player.y;
            } // end if
        } // end of for
    } // End of the function
    function mainHumanControl(id, player, teamNode)
    {
        var limit;
        var teamMate;
        if (player.ballPasseId == _leBallon.passeCmpt)
        {
            if (Key.isDown(32))
            {
                player.pause = true;
                player.xTarget = _parent._xmouse;
                player.yTarget = _parent._ymouse;
                dx = player.xTarget - player.x;
                dy = player.yTarget - player.y;
                distance = Math.sqrt(dx * dx + dy * dy);
                if (distance > 0.001000)
                {
                    dx = dx / distance;
                    dy = dy / distance;
                    angle = Math.atan2(dx, -dy);
                    player.angle = angle;
                } // end if
            }
            else if (_bKeepBallTraj == 1)
            {
                x1 = player.x;
                y1 = player.y;
                dx = _parent._xmouse - x1;
                dy = _parent._ymouse - y1;
                cos = _leBallon.nx * dx + _leBallon.ny * dy;
                player.xTarget = x1 + cos * _leBallon.nx;
                player.yTarget = y1 + cos * _leBallon.ny;
            }
            else if (_bKeepBallTraj == 2)
            {
                player.xTarget = player.x;
                player.yTarget = player.y;
            }
            else
            {
                player.xTarget = _parent._xmouse;
                player.yTarget = _parent._ymouse;
            } // end else if
            return;
        } // end if
        if (_curPorteur == id && Key.isDown(32))
        {
            player.xTarget = player.x + Math.sin(player.angle) * 20;
            player.yTarget = player.y - Math.cos(player.angle) * 20;
        }
        else if (Key.isDown(32))
        {
            player.pause = true;
            player.xTarget = _parent._xmouse;
            player.yTarget = _parent._ymouse;
            dx = player.xTarget - player.x;
            dy = player.yTarget - player.y;
            distance = Math.sqrt(dx * dx + dy * dy);
            if (distance > 0.001000)
            {
                dx = dx / distance;
                dy = dy / distance;
                angle = Math.atan2(dx, -dy);
                player.angle = angle;
            } // end if
        }
        else
        {
            player.xTarget = _parent._xmouse;
            player.yTarget = _parent._ymouse;
        } // end else if
        if (_curPorteur > 0 && _curPorteur < 5)
        {
            if (Key.isDown(13))
            {
                player.pause = false;
                xb = _xMField + 200 * _teamTable[0].signeDir;
                yb = _yMField + (Math.random() - 0.500000) * 80;
                ballShootGoal(player, xb, yb, _teamTable[0].shootSpeed);
                _butPlayer = -1;
            } // end if
        } // end if
        if (id % 5 != 0)
        {
            if (_curPorteur == 5)
            {
                if (teamNode.signeDir < 0)
                {
                    limit = _xMField - 140;
                    if (player.xTarget < limit)
                    {
                        player.xTarget = limit;
                    } // end if
                }
                else
                {
                    limit = _xMField + 140;
                    if (limit < player.xTarget)
                    {
                        player.xTarget = limit;
                    } // end if
                } // end if
            } // end else if
            return;
        } // end if
        if (_curPorteur == id)
        {
            player.possession = player.possession + _nbMs;
            if (player.possession > 6000)
            {
                teamMate = computePasseTable(id, teamNode);
                if (teamMate >= 0)
                {
                    ballPasse(_players[teamMate], teamNode.passeSpeed, 0);
                } // end if
            } // end if
        } // end if
        if (player.yTarget < _y0Buts)
        {
            player.yTarget = _y0Buts;
        }
        else if (_y3Buts < player.yTarget)
        {
            player.yTarget = _y3Buts;
        } // end else if
        limit = _xMField - teamNode.signeDir * 150;
        if (teamNode.signeDir < 0)
        {
            if (player.xTarget < limit)
            {
                player.xTarget = limit;
            } // end if
        }
        else if (limit < player.xTarget)
        {
            player.xTarget = limit;
        } // end else if
    } // End of the function
    function mainCpuControl(id, player, teamNode)
    {
        var xb;
        var yb;
        var bPasse;
        var teamMate;
        if (id != _curPorteur)
        {
            joueurAI_attaqueBackUp(player, teamNode);
            return;
        } // end if
        bPasse = 0;
        if (player.comportementFirstFrame != true)
        {
            if (player.distToDo < 100)
            {
                player.comportementFirstFrame = true;
                bPasse = 2;
            } // end if
        } // end if
        if (player.comportementFirstFrame == true)
        {
            player.comportementFirstFrame = false;
            oldX = player.xTarget;
            player.xTarget = _xMField + teamNode.signeDir * (110 + Math.random() * 30);
            if (bPasse == 2)
            {
                oldX = oldX - player.xTarget;
                if (teamNode.signeDir < 0 && oldX < 0)
                {
                    bPasse = 3;
                }
                else if (teamNode.signeDir > 0 && oldX > 0)
                {
                    bPasse = 3;
                } // end if
            } // end else if
            Q = Math.random() - 0.500000;
            if (Math.abs(Q) < 0.250000)
            {
                if (Q >= 0)
                {
                    Q = 0.250000;
                }
                else
                {
                    Q = -0.250000;
                } // end if
            } // end else if
            player.yTarget = _yMField + Q * 150;
        }
        else
        {
            player.possession = player.possession + _nbMs;
            if (player.possession > 500)
            {
                for (i = 0; i < player.nbProbsCheck; i++)
                {
                    if (teamNode.curPasseProba < Math.random())
                    {
                        bPasse = 1;
                        player.possession = 0;
                    } // end if
                } // end of for
            } // end if
        } // end else if
        canShoot = false;
        if (teamNode.signeDir < 0)
        {
            if (player.x < _xMField + teamNode.signeDir * 80)
            {
                canShoot = true;
            } // end if
        }
        else if (_xMField + teamNode.signeDir * 80 < player.x)
        {
            canShoot = true;
        } // end else if
        if (canShoot == true)
        {
            dy = _yMField - _players[0].y;
            if (dy < -15)
            {
                if (player.y < _yMField + 50)
                {
                    bPasse = 3;
                } // end if
            }
            else if (dy > 15)
            {
                if (_yMField - 50 < player.y)
                {
                    bPasse = 3;
                } // end if
            } // end else if
            if (bPasse == 1)
            {
                bPasse = 2;
            } // end if
        } // end if
        if (_bShootDirect == true)
        {
            bPasse = 3;
            _bShootDirect = false;
        } // end if
        if (bPasse == 1)
        {
            teamMate = computePasseTable(id, teamNode);
            if (teamMate >= 0)
            {
                ballPasse(_players[teamMate], teamNode.passeSpeed, 0);
            } // end if
        } // end if
        if (bPasse == 2)
        {
            teamMate = computePasseTable(id, teamNode);
            if (teamMate >= 0)
            {
                _bShootDirect = true;
                ballPasse(_players[teamMate], teamNode.passeSpeed, 0);
            } // end if
            return;
        } // end if
        if (bPasse == 3)
        {
            xb = _xMField + 200 * teamNode.signeDir;
            yb = _yMField - _players[0].y;
            if (yb > 0)
            {
                yb = _yMField + 27;
            }
            else
            {
                yb = _yMField - 27;
            } // end else if
            _probaBlocShoot = 0.500000;
            ballShootGoal(player, xb, yb, teamNode.shootSpeed);
        } // end if
    } // End of the function
    function goalAI_seekBall(id, player, teamNode)
    {
        goalAI_waitBut(id, player, teamNode);
    } // End of the function
    function goalAI_waitBut(id, player, teamNode)
    {
        var teamMate;
        if (id == _curPorteur)
        {
            player.xTarget = player.xBase - teamNode.signeDir * 10;
            player.possession = player.possession + _nbMs;
            if (player.possession > 2500)
            {
                teamMate = computePasseTable(id, teamNode);
                if (teamMate >= 0)
                {
                    ballPasse(_players[teamMate], teamNode.passeSpeed, 0);
                } // end if
            } // end if
            return;
        }
        else
        {
            x2 = _leBallon.x;
            y2 = _leBallon.y;
            if (_curPorteur < 0)
            {
                dx = x2 - player.x;
                dy = y2 - player.y;
                dist = Math.sqrt(dx * dx + dy * dy);
                if (dist < 40)
                {
                    player.xTarget = x2;
                    player.yTarget = y2;
                    return;
                } // end if
            } // end if
            x1 = _xMField - teamNode.signeDir * 210;
            y1 = player.yBase;
            dx = x2 - x1;
            dy = y2 - y1;
            taille = Math.sqrt(dx * dx + dy * dy);
            if (taille > 0.001000)
            {
                dx = dx / taille;
                dy = dy / taille;
            } // end if
            dist = taille * 0.500000;
            if (dist > 75)
            {
                dist = 75;
            } // end if
            player.xTarget = x1 + dx * dist;
            player.yTarget = y1 + dy * dist;
        } // end else if
    } // End of the function
    function goalAI_keepBut(id, player, teamNode)
    {
        var x1;
        var y1;
        var x2;
        var y2;
        var exitIt;
        if (id == _curPorteur)
        {
            player.xTarget = player.xBase;
            player.yTarget = player.yBase;
            player.possession = player.possession + _nbMs;
            if (player.possession > 2500)
            {
                if (Math.random() > 0.800000)
                {
                    teamMate = computePasseTable(id, teamNode);
                    if (teamMate >= 0)
                    {
                        ballPasse(_players[teamMate], teamNode.passeSpeed, 0);
                    } // end if
                } // end if
            } // end if
            return;
        } // end if
        if (_leBallon.bToGoal == true)
        {
            if (_goalCanBoost == true)
            {
                playerBoost(player);
            } // end if
            player.xTarget = _xGoalTarget;
            player.yTarget = _yGoalTarget;
            return;
        } // end if
        x1 = _xMField - teamNode.signeDir * 210;
        y1 = player.yBase;
        x2 = _leBallon.x;
        y2 = _leBallon.y;
        dx = x2 - x1;
        dy = y2 - y1;
        taille = Math.sqrt(dx * dx + dy * dy);
        if (taille > 0.001000)
        {
            dx = dx / taille;
            dy = dy / taille;
        } // end if
        dist = (2 - teamNode.alertLevel) * 45;
        if (dist < 45)
        {
            dist = 45;
        } // end if
        player.xTarget = x1 + dx * dist;
        player.yTarget = y1 + dy * dist;
        if (teamNode.signeDir < 0)
        {
            limit = _xMField + 165;
            if (player.xTarget < limit)
            {
                player.xTarget = limit;
            } // end if
        }
        else
        {
            limit = _xMField - 165;
            if (limit < player.xTarget)
            {
                player.xTarget = limit;
            } // end if
        } // end else if
        if (player.yTarget < _y0Buts)
        {
            player.yTarget = _y0Buts;
        }
        else if (_y3Buts < player.yTarget)
        {
            player.yTarget = _y3Buts;
        } // end else if
        if (teamNode.alertLevel == 2)
        {
            if (id == _curSendeur && _sentTimer >= 0)
            {
                return;
            } // end if
            if (teamNode.GoalStyle == 1)
            {
                if (inRange(player.x, player.y, _leBallon.x, _leBallon.y, 60) == true)
                {
                    player.xTarget = _leBallon.x;
                    player.yTarget = _leBallon.y;
                    if (teamNode.signeDir < 0)
                    {
                        limit = _xMField + 165;
                        if (player.xTarget < limit)
                        {
                            player.xTarget = limit;
                        } // end if
                    }
                    else
                    {
                        limit = _xMField - 165;
                        if (limit < player.xTarget)
                        {
                            player.xTarget = limit;
                        } // end if
                    } // end else if
                    if (player.yTarget < _y0Buts)
                    {
                        player.yTarget = _y0Buts;
                    }
                    else if (_y3Buts < player.yTarget)
                    {
                        player.yTarget = _y3Buts;
                    } // end if
                } // end if
            } // end else if
            if (_leBallon.z < 5)
            {
                if (inRange(player.x, player.y, _leBallon.x, _leBallon.y, 10) == true)
                {
                    if (_sons == true)
                    {
                        sonTacle.start();
                    } // end if
                    ballNewPorteur(id);
                } // end if
            } // end if
        } // end if
    } // End of the function
    function joueurAI_seekBall(player, teamNode)
    {
        player.xTarget = _leBallon.x;
        player.yTarget = _leBallon.y;
    } // End of the function
    function joueurAI_relanceAdv(player, teamNode)
    {
        if (player.comportementFirstFrame == true)
        {
            player.comportementFirstFrame = false;
            if (player.poste <= 2)
            {
                player.xTarget = player.xBase;
                player.yTarget = player.yBase;
            }
            else
            {
                player.xTarget = _xMField + (50 + Math.random() * 30) * teamNode.signeDir;
                player.yTarget = player.yBase + (Math.random() - 0.500000) * 40;
            } // end if
        } // end else if
    } // End of the function
    function joueurAI_relanceFrd(player, teamNode)
    {
        if (player.comportementFirstFrame == true)
        {
            player.comportementFirstFrame = false;
            if (player.poste <= 2)
            {
                player.xTarget = player.xBase + Math.random() * 40 * teamNode.signeDir;
                player.yTarget = player.yBase;
            }
            else
            {
                player.xTarget = _xMField + (70 + Math.random() * 50) * teamNode.signeDir;
                player.yTarget = player.yBase + (Math.random() - 0.500000) * 40;
            } // end if
        } // end else if
    } // End of the function
    function teamAttaqueFlagsCompute(teamNode)
    {
        var i;
        var j;
        var dx;
        var dy;
        var zone;
        var mainZone;
        var playerNode;
        var nbAttaquers;
        var nbDefencers;
        for (i = 0; i < 3; i++)
        {
            _attaqueFlags[i] = 0;
        } // end of for
        nbAttaquers = 0;
        for (i = 0; i < 5; i++)
        {
            playerIndex = teamNode.sortedList1[i].player;
            playerNode = _players[playerIndex];
            if (playerNode.comportement == "playerControlled" || playerNode.comportement == "P_attaque_BackUp" || playerNode.comportement == "cpuControlled")
            {
                ++nbAttaquers;
            } // end if
            playerNode.attaqueZone = -1;
        } // end of for
        if (nbAttaquers == 0)
        {
            teamNode.nbDefencers = 4;
            return;
        } // end if
        nbDefencers = 0;
        for (i = 1; i < 5; i++)
        {
            playerIndex = teamNode.sortedList1[i].player;
            playerNode = _players[playerIndex];
            dx = (_xMField - playerNode.x) * teamNode.signeDir;
            if (dx > 10)
            {
                ++nbDefencers;
            } // end if
        } // end of for
        teamNode.nbDefencers = nbDefencers;
        for (i = 0; i < 5; i++)
        {
            playerIndex = teamNode.sortedList1[i].player;
            playerNode = _players[playerIndex];
            if (playerNode.comportement == "playerControlled" || _curPorteur == playerIndex)
            {
                dy = _yMField - playerNode.y;
                if (Math.abs(dy) < 50)
                {
                    zone = 1;
                }
                else if (dy > 0)
                {
                    zone = 0;
                }
                else
                {
                    zone = 2;
                } // end else if
                _attaqueFlags[zone] = 2;
                playerNode.attaqueZone = zone;
                mainZone = zone;
            } // end if
        } // end of for
        if (nbAttaquers < 3)
        {
            for (i = 0; i < 5; i++)
            {
                playerIndex = teamNode.sortedList1[i].player;
                if (_curPorteur == playerIndex)
                {
                    continue;
                } // end if
                playerNode = _players[playerIndex];
                if (playerNode.comportement == "P_attaque_BackUp")
                {
                    if (mainZone == 1)
                    {
                        dy = _yMField - playerNode.y;
                        if (dy > 0)
                        {
                            zone = 0;
                        }
                        else
                        {
                            zone = 2;
                        } // end else if
                    }
                    else
                    {
                        zone = 1;
                    } // end else if
                    _attaqueFlags[zone] = 1;
                    playerNode.attaqueZone = zone;
                } // end if
            } // end of for
        }
        else
        {
            for (i = 0; i < 5; i++)
            {
                playerIndex = teamNode.sortedList1[i].player;
                if (_curPorteur == playerIndex)
                {
                    continue;
                } // end if
                playerNode = _players[playerIndex];
                if (playerNode.comportement == "P_attaque_BackUp" || playerNode.comportement == "cpuControlled")
                {
                    dy = _yMField - playerNode.y;
                    if (Math.abs(dy) < 50)
                    {
                        zone = 1;
                    }
                    else if (dy > 0)
                    {
                        zone = 0;
                    }
                    else
                    {
                        zone = 2;
                    } // end else if
                    if (_attaqueFlags[zone] != 0)
                    {
                        for (j = 0; j < 3; j++)
                        {
                            if (_attaqueFlags[j] == 0)
                            {
                                zone = j;
                                break;
                            } // end if
                        } // end of for
                    } // end if
                    _attaqueFlags[zone] = 1;
                    playerNode.attaqueZone = zone;
                } // end if
            } // end of for
        } // end else if
    } // End of the function
    function joueurAI_attaqueBackUp(player, teamNode)
    {
        var dy;
        var dist;
        var limit;
        var xTarget;
        if (player.comportementFirstFrame != true)
        {
            if (player.comportementParam != player.attaqueZone)
            {
                player.comportementFirstFrame = true;
            }
            else if (player.distToDo < 1)
            {
                player.comportementFirstFrame = true;
            }
            else
            {
                dx = player.x - _leBallon.x;
                if (dx < -10)
                {
                    if (teamNode.signeDir > 0)
                    {
                        playerBoost(player);
                    } // end if
                }
                else if (dx > 10)
                {
                    if (teamNode.signeDir < 0)
                    {
                        playerBoost(player);
                    } // end if
                } // end else if
            } // end else if
        } // end else if
        if (player.comportementFirstFrame == true)
        {
            player.comportementFirstFrame = false;
            player.comportementParam = player.attaqueZone;
            dy = _yMField - _leBallon.y;
            if (player.attaqueZone == 0)
            {
                player.yTarget = _y0Buts - Math.random() * 40;
                xTarget = _leBallon.x + 40 * teamNode.signeDir;
                limit = _xMField + 165 * teamNode.signeDir;
            }
            else if (player.attaqueZone == 1)
            {
                player.yTarget = _yMField + (Math.random() - 0.500000) * 70;
                xTarget = _leBallon.x + 20 * teamNode.signeDir;
                limit = _xMField + 140 * teamNode.signeDir;
            }
            else
            {
                player.yTarget = _y3Buts + Math.random() * 40;
                xTarget = _leBallon.x + 40 * teamNode.signeDir;
                limit = _xMField + 165 * teamNode.signeDir;
            } // end else if
            dx = player.x - _leBallon.x;
            if (teamNode.signeDir > 0)
            {
                if (limit < xTarget)
                {
                    xTarget = limit;
                } // end if
                if (player.xTarget < xTarget)
                {
                    player.xTarget = xTarget;
                } // end if
            }
            else
            {
                if (xTarget < limit)
                {
                    xTarget = limit;
                } // end if
                if (xTarget < player.xTarget)
                {
                    player.xTarget = xTarget;
                } // end if
            } // end if
        } // end else if
    } // End of the function
    function joueurAI_attaquePlacementDefence(player, teamNode)
    {
        var poste;
        var playerSide;
        if (player.comportementFirstFrame != true)
        {
            if (player.comportementParam != -1)
            {
                if (_leBallon.side == teamNode.side)
                {
                    poste = player.poste;
                    player.xTarget = player.xBase;
                    player.yTarget = player.yBase;
                    player.comportementParam = -1;
                } // end if
            }
            else
            {
                player.bBrake = true;
                player.tmpTimer = player.tmpTimer - _nbMs;
                if (player.tmpTimer <= 0)
                {
                    player.tmpTimer = Math.random() * 800 + 500;
                    if (_leBallon.side != teamNode.side)
                    {
                        dt = Math.abs(_leBallon.x - _xMField) + Math.random() * 40;
                        poste = player.poste;
                        if (teamNode.nbDefencers <= 1)
                        {
                            player.xTarget = player.xBase + dt * teamNode.signeDir * 0.200000;
                            player.yTarget = _yMField + (Math.random() - 0.500000) * 50;
                        }
                        else
                        {
                            player.xTarget = player.xBase + dt * teamNode.signeDir * 0.450000;
                            player.yTarget = player.yBase + (Math.random() - 0.500000) * 50;
                        } // end if
                    } // end if
                } // end if
            } // end else if
        } // end else if
        if (player.comportementFirstFrame == true)
        {
            player.comportementFirstFrame = false;
            player.tmpTimer = Math.random() * 800 + 500;
            if (player.x < _xMField)
            {
                playerSide = 0;
            }
            else
            {
                playerSide = 1;
            } // end else if
            if (playerSide == teamNode.side)
            {
                poste = player.poste;
                player.xTarget = player.xBase + (Math.random() - 0.500000) * 50;
                player.yTarget = player.yBase + (Math.random() - 0.500000) * 50;
                player.comportementParam = -1;
            }
            else
            {
                player.xTarget = _xMField + (Math.random() - 0.500000) * 10;
                player.yTarget = _yMField + (Math.random() - 0.500000) * 100;
                player.comportementParam = playerSide;
            } // end if
        } // end else if
    } // End of the function
    function joueurAI_defendCatch(player, teamNode)
    {
        var angle;
        var xTarget;
        var yTarget;
        if (player.comportementFirstFrame != true)
        {
            if (player.distToDo < 1 && Math.random() > 0.700000)
            {
                player.defendCatchLevel = 1;
            } // end if
        } // end if
        if (player.comportementFirstFrame == true)
        {
            player.defendCatchLevel = 0;
            player.comportementFirstFrame = false;
        } // end if
        if (player.defendCatchLevel == 0)
        {
            if (_curPorteur < 0)
            {
                xTarget = _leBallon.x;
                yTarget = _leBallon.y;
            }
            else
            {
                angle = _players[_curPorteur].angleBallon;
                xTarget = _players[_curPorteur].x + Math.cos(angle) * 30;
                yTarget = _players[_curPorteur].y + Math.sin(angle) * 30;
            } // end else if
            player.xTarget = xTarget;
            player.yTarget = yTarget;
        }
        else if (player.defendCatchLevel == 1)
        {
            player.xTarget = _leBallon.x;
            player.yTarget = _leBallon.y;
        } // end else if
        if (inRange(player.x, player.y, _leBallon.x, _leBallon.y, 20) == true)
        {
            if (_curPorteur >= 0)
            {
                if (_curPorteur % 5 != 0)
                {
                    for (i = 0; i < player.nbProbsCheck; i++)
                    {
                        if (teamNode.tacleProba < Math.random() && player.action != 4)
                        {
                            player.xTarget = _leBallon.x;
                            player.yTarget = _leBallon.y;
                            trigerTacle(player);
                            break;
                            continue;
                        } // end if
                        if (Math.random() > 0.950000)
                        {
                            player.defendCatchLevel = 0;
                            break;
                        } // end if
                    } // end of for
                } // end if
            } // end if
        } // end if
    } // End of the function
    function joueurAI_defendMarquage(player, teamNode)
    {
        if (player.comportementFirstFrame != true)
        {
            if (inRange(player.x, player.y, _leBallon.x, _leBallon.y, 20) == true)
            {
                if (_curPorteur >= 0)
                {
                    if (_curPorteur % 5 != 0)
                    {
                        for (i = 0; i < player.nbProbsCheck; i++)
                        {
                            if (teamNode.tacleProba < Math.random() && player.action != 4)
                            {
                                trigerTacle(player);
                                return;
                            } // end if
                        } // end of for
                    } // end if
                } // end if
            } // end if
            if (player.distToDo < 1)
            {
                if (Math.random() > 0.900000)
                {
                    player.comportementFirstFrame = true;
                } // end if
            } // end if
        } // end if
        if (player.comportementFirstFrame == true)
        {
            player.comportementFirstFrame = false;
            if (_curMarquage >= 0)
            {
                x1 = _leBallon.x;
                y1 = _leBallon.y;
                x2 = _players[_curMarquage].x;
                y2 = _players[_curMarquage].y;
                dx = x2 - x1;
                dy = y2 - y1;
                player.xTarget = x2 - dx * 0.500000;
                player.yTarget = y2 - dy * 0.500000;
            }
            else
            {
                player.xTarget = _leBallon.x;
                player.yTarget = _leBallon.y;
            } // end if
        } // end else if
    } // End of the function
    function joueurAI_defendGoal(player, teamNode, upDwn)
    {
        var poste;
        var inZone;
        if (player.comportementFirstFrame != true)
        {
            inZone = false;
            if (_leBallon.side == teamNode.side)
            {
                if (upDwn == 0)
                {
                    if (_yMField >= _leBallon.y)
                    {
                        inZone = true;
                    } // end if
                }
                else if (_leBallon.y >= _yMField)
                {
                    inZone = true;
                } // end if
            } // end else if
            player.tmpTimer2 = player.tmpTimer2 - _nbMs;
            if (inZone != true && player.comportementParam == "track")
            {
                player.comportementParam = "untrack";
                player.comportementFirstFrame = true;
                player.tmpTimer2 = 500;
            } // end if
            if (player.tmpTimer2 <= 0)
            {
                if (inRange(player.x, player.y, _leBallon.x, _leBallon.y, 60) == true)
                {
                    player.xTarget = _leBallon.x;
                    player.yTarget = _leBallon.y;
                    player.comportementParam = "track";
                    if (inRange(player.x, player.y, _leBallon.x, _leBallon.y, 20) == true)
                    {
                        if (_curPorteur >= 0)
                        {
                            if (_curPorteur % 5 != 0)
                            {
                                for (i = 0; i < player.nbProbsCheck; i++)
                                {
                                    if (teamNode.tacleProba < Math.random() && player.action != 4)
                                    {
                                        trigerTacle(player);
                                        return;
                                    } // end if
                                } // end of for
                            } // end if
                        } // end if
                    } // end if
                }
                else
                {
                    player.comportementParam = "untrack";
                } // end if
            } // end else if
            if (player.comportementParam != "track")
            {
                player.bBrake = true;
                player.tmpTimer = player.tmpTimer - _nbMs;
                if (player.tmpTimer <= 0)
                {
                    player.tmpTimer = Math.random() * 200 + 200;
                    if (Math.random() > 0.700000)
                    {
                        player.comportementFirstFrame = true;
                    } // end if
                } // end if
            } // end if
        } // end if
        if (player.comportementFirstFrame == true)
        {
            player.comportementFirstFrame = false;
            player.tmpTimer = 200;
            poste = player.poste;
            player.xTarget = player.xBase;
            player.yTarget = player.yBase;
            player.xTarget = player.xTarget + (Math.random() - 0.500000) * 50;
            player.yTarget = player.yTarget + (Math.random() - 0.500000) * 50;
            player.comportementParam = "untrack";
        } // end if
    } // End of the function
    function managePlayersWon(teamNum)
    {
        var i;
        var index;
        var avX;
        var avY;
        var player;
        index = teamNum * 5;
        avX = _xMField;
        avY = _yMField;
        for (i = index + 1; i < index + 5; i++)
        {
            player = _players[i];
            avX = avX + player.x;
            avY = avY + player.y;
        } // end of for
        avX = avX / 5;
        avY = avY / 5;
        for (i = index + 1; i < index + 5; i++)
        {
            player = _players[i];
            dx = player.x - player.xTarget;
            dy = player.y - player.yTarget;
            distance = dx * dx + dy * dy;
            if (distance < 3)
            {
                player.comportementFirstFrame = false;
                player.xTarget = avX + (Math.random() - 0.500000) * 75;
                player.yTarget = avY + (Math.random() - 0.500000) * 75;
            } // end if
        } // end of for
    } // End of the function
    function managePlayersLost(teamNum)
    {
        var i;
        var index;
        var player;
        index = teamNum * 5;
        for (i = index + 1; i < index + 5; i++)
        {
            player = _players[i];
            player.xTarget = player.xBase;
            player.yTarget = player.yBase;
        } // end of for
    } // End of the function
    function computePasseTable(id, teamNode)
    {
        var i;
        var x1;
        var y1;
        var x2;
        var y2;
        var dx;
        var dy;
        var adx;
        var best;
        var bestAdx;
        var norme;
        var angle;
        var oponent;
        if (id < 5)
        {
            team1 = 1;
            team2 = 5;
        }
        else
        {
            team1 = 6;
            team2 = 0;
        } // end else if
        ptr = 0;
        for (i = team1; i < team1 + 4; i++)
        {
            if (i == id)
            {
                continue;
            } // end if
            dx = _players[i].x - _players[id].x;
            adx = dx * teamNode.signeDir;
            if (adx < -150)
            {
                continue;
            } // end if
            dy = _players[i].y - _players[id].y;
            taille = Math.sqrt(dx * dx + dy * dy);
            if (taille < 5)
            {
                continue;
            } // end if
            _playerPasseTable[ptr].playerId = i;
            _playerPasseTable[ptr].adx = adx;
            _playerPasseTable[ptr].dx = dx / taille;
            _playerPasseTable[ptr].dy = dy / taille;
            ++ptr;
        } // end of for
        if (ptr >= 3)
        {
            if (_playerPasseTable[1].adx < _playerPasseTable[2].adx)
            {
                tmp = _playerPasseTable[1];
                _playerPasseTable[1] = _playerPasseTable[2];
                _playerPasseTable[2] = tmp;
            } // end if
        } // end if
        if (ptr >= 2)
        {
            if (_playerPasseTable[0].adx < _playerPasseTable[1].adx)
            {
                tmp = _playerPasseTable[0];
                _playerPasseTable[0] = _playerPasseTable[1];
                _playerPasseTable[1] = tmp;
            } // end if
        } // end if
        for (i = 0; i < ptr; i++)
        {
            playerId = _playerPasseTable[i].playerId;
            bFailed = false;
            for (j = team2; j < team2 + 5; j++)
            {
                dx = _players[j].x - _players[id].x;
                if (Math.abs(dx) > 50)
                {
                    continue;
                } // end if
                dy = _players[j].y - _players[id].y;
                if (Math.abs(dy) > 50)
                {
                    continue;
                } // end if
                taille = Math.sqrt(dx * dx + dy * dy);
                if (taille < 10)
                {
                    bFailed = true;
                    break;
                } // end if
                dx = dx / taille;
                dy = dy / taille;
                myCos = dx * _playerPasseTable[i].dx + dy * _playerPasseTable[i].dy;
                if (_passCosTrash < myCos)
                {
                    bFailed = true;
                    break;
                } // end if
            } // end of for
            if (bFailed == false)
            {
                return (playerId);
            } // end if
        } // end of for
        return (-1);
    } // End of the function
    function newPlayer(id, teamNum, baseSpeed)
    {
        var player;
        var teamNode;
        player = new Object();
        _players[id] = player;
        teamNode = _teamTable[teamNum];
        player.baseSpeed = baseSpeed;
        player.pause = false;
        player.id = id;
        player.teamNum = teamNum;
        player.x = _xMField;
        player.y = _yMField;
        player.xBase = player.x;
        player.yBase = player.y;
        player.xTarget = player.x;
        player.yTarget = player.y;
        player.poste = id % 5;
        player.oldNx = 0;
        player.oldNy = 1;
        player.comportement = "P_stop";
        player.comportementParam = -1;
        player.probaTimer = id * 5;
        _probaTimerLimit = 128;
        player.bBrake = false;
        player.nbProbsCheck = 0;
        player.godTimer = 0;
        player.catchRayon = teamNode.catchRayon;
        player.boostDuration = teamNode.boostDuration;
        player.tmpTimer = 0;
        player.tmpTimer2 = 0;
        player.possession = 0;
        player.boost = 0;
        player.action = 0;
        player.ori = 1;
        player.animNbFrames = 1;
        player.angle = 0;
        player.angleBallon = 0;
        player.btName = "bouton" + id;
        player.clipName = "player" + id;
        player.depth = id + 20;
        player.oldFrame = 1;
        player.ballPasseId = -1;
        _parent.playersNode.attachMovie(_playerIds[id], player.clipName, player.depth);
        if (_btVisible == true && id != 0)
        {
            _parent.playersNode.attachMovie("bt1", player.btName, player.depth - 19);
        }
        else
        {
            _parent.playersNode.attachMovie("bt2", player.btName, player.depth - 19);
        } // end else if
        player.btName = "_parent.playersNode.bouton" + id;
        player.clipName = "_parent.playersNode.player" + id;
        eval(player.btName).bouton._xscale = 120;
        eval(player.btName).bouton._yscale = 120;
        eval(player.clipName)._visible = true;
        eval(player.clipName).cercle._visible = false;
        eval(player.clipName).trainee._visible = false;
        eval(player.clipName).mcGod._visible = false;
        eval(player.clipName).mcBoost._visible = false;
        eval(player.clipName).gotoAndStop(1);
        eval(player.clipName)._x = player.x;
        eval(player.clipName)._y = player.y;
        eval(player.clipName)._xscale = 30;
        eval(player.clipName)._yscale = 30;
        if (_debug == true)
        {
            eval(player.clipName).numero = id;
        } // end if
        eval(player.btName)._visible = false;
        eval(player.btName)._alpha = 50;
        eval(player.btName)._x = player.x;
        eval(player.btName)._y = player.y;
        eval(player.btName)._xscale = 30;
        eval(player.btName)._yscale = 30;
        if (id == 0)
        {
            eval(player.btName).bouton._xscale = 100;
            eval(player.btName).bouton._yscale = 100;
        }
        else if (id < 5)
        {
            eval(player.btName).bouton._xscale = _ctrlRange;
            eval(player.btName).bouton._yscale = _ctrlRange;
        } // end else if
    } // End of the function
    function selectPlayer(playerNum)
    {
        if (_curPlayer >= 0)
        {
            setProperty(eval(_players[_curPlayer].clipName).cercle, _visible, false);
            setProperty(eval(_players[_curPlayer].btName), _visible, true);
            eval(_players[_curPlayer].clipName).mcBoost._visible = false;
        } // end if
        _curPlayer = playerNum;
        if (_curPlayer >= 0)
        {
            setProperty(eval(_players[_curPlayer].clipName).cercle, _visible, true);
            setProperty(eval(_players[_curPlayer].btName), _visible, true);
            eval(_players[_curPlayer].clipName).mcBoost._visible = true;
            _players[_curPlayer].nbBoost = 5;
            eval(_players[_curPlayer].clipName).mcBoost.gotoAndStop(6);
        } // end if
        _aiRefreshTimer = 0;
    } // End of the function
    function playerBoost(player)
    {
        if (player.nbBoost < 1)
        {
            return;
        } // end if
        if (player.boost != 0)
        {
            return;
        } // end if
        player.boost = 1;
        player.boostTimer = player.boostDuration;
        setProperty(eval(player.clipName).trainee, _visible, true);
        setProperty(eval(player.clipName).trainee, _rotation, player.degre);
        if (_sons == true && player.id == _curPlayer)
        {
            sonAccelerate.start();
        } // end if
        --player.nbBoost;
        if (player.id >= 5)
        {
            return;
        } // end if
        eval(player.clipName).mcBoost.gotoAndStop(player.nbBoost + 1);
    } // End of the function
    function managePlayers()
    {
        var i;
        var Q;
        var flag;
        var once;
        var player1;
        var player2;
        _arbitre.nbMovingPlayers = 0;
        for (i = 0; i < 10; i++)
        {
            managePlayer(i, _players[i]);
        } // end of for
        for (i = 0; i < 10; i++)
        {
            setProperty(eval(_players[i].btName), _x, _players[i].x);
            setProperty(eval(_players[i].btName), _y, _players[i].y);
            setProperty(eval(_players[i].clipName), _x, _players[i].x);
            setProperty(eval(_players[i].clipName), _y, _players[i].y);
        } // end of for
        once = false;
        do
        {
            flag = false;
            for (i = 0; i < 9; i++)
            {
                player1 = _playerSortTable[i];
                player2 = _playerSortTable[i + 1];
                if (player2.y < player1.y)
                {
                    flag = true;
                    once = true;
                    _playerSortTable[i] = player2;
                    _playerSortTable[i + 1] = player1;
                } // end if
            } // end of for
        } while (flag == true)
        if (once == false)
        {
            return;
        } // end if
        _bank = _bank ^ 1;
        for (i = 0; i < 10; i++)
        {
            player1 = _playerSortTable[i];
            depth = _bank * 100 + i + 20;
            eval(player1.clipName).swapDepths(depth);
        } // end of for
    } // End of the function
    function managePlayer(id, player)
    {
        var x1;
        var y1;
        var x2;
        var y2;
        var dx;
        var dy;
        var nx;
        var ny;
        var nx2;
        var ny2;
        var dot1;
        var dot2;
        var side;
        var ori;
        var distance;
        var vitesse;
        teamNum = player.teamNum;
        x1 = player.x;
        y1 = player.y;
        player.xOld = x1;
        player.yOld = y1;
        if (player.godTimer > 0)
        {
            player.godTimer = player.godTimer - _nbMs;
            if (player.godTimer < 0)
            {
                setProperty(eval(player.clipName).mcGod, _visible, false);
                if (_sons == true)
                {
                    sonBonus.stop();
                } // end if
            } // end if
        } // end if
        if (player.action == 4)
        {
            playerManageTacle(player);
            nx = player.tacleNx;
            ny = player.tacleNy;
            vitesse = _teamTable[teamNum].playerSpeed;
            dx = nx * vitesse * _nbMs * 0.001000;
            dy = ny * vitesse * _nbMs * 0.001000;
            x2 = x1 + dx;
            y2 = y1 + dy;
            dot1 = dx * dx + dy * dy;
        } // end if
        if (player.action == 10)
        {
            player.tacleTimer = player.tacleTimer - _nbMs;
            if (player.tacleTimer <= 0 && player.tacleFirstFrame == false)
            {
                playerDemare(player);
            }
            else
            {
                player.tacleFirstFrame = false;
            } // end else if
            nx = player.tacleNx;
            ny = player.tacleNy;
            vitesse = _teamTable[teamNum].playerSpeed;
            dx = nx * vitesse * _nbMs * 0.001000;
            dy = ny * vitesse * _nbMs * 0.001000;
            x2 = x1 + dx;
            y2 = y1 + dy;
            dot1 = dx * dx + dy * dy;
        }
        else if (player.action != 4)
        {
            if (player.pause == true)
            {
                if (_butPlayer != id)
                {
                    dx = x1 - _parent._xmouse;
                    dy = y1 - _parent._ymouse;
                    dist = Math.sqrt(dx * dx + dy * dy);
                    if (dist > 30 || _arbitre.action != "play")
                    {
                        player.pause = false;
                    } // end if
                } // end if
                x2 = x1;
                y2 = y1;
            }
            else
            {
                x2 = player.xTarget;
                y2 = player.yTarget;
                if (x2 < _x1Field)
                {
                    x2 = _x1Field;
                    player.xTarget = x2;
                }
                else if (_x2Field < x2)
                {
                    x2 = _x2Field;
                    player.xTarget = x2;
                } // end else if
                if (y2 < _y1Field)
                {
                    y2 = _y1Field;
                    player.yTarget = y2;
                }
                else if (_y2Field < y2)
                {
                    y2 = _y2Field;
                    player.yTarget = y2;
                } // end else if
            } // end else if
            dx = x2 - x1;
            dy = y2 - y1;
            dot1 = dx * dx + dy * dy;
            distance = Math.sqrt(dot1);
            if (distance > 0.010000)
            {
                nx = dx / distance;
                ny = dy / distance;
                if (player.action != 2)
                {
                    playerDemare(player);
                } // end if
                vitesse = player.baseSpeed;
            }
            else
            {
                if (player.action != 0)
                {
                    playerArrete(player);
                } // end if
                dx = _leBallon.x - x1;
                dy = _leBallon.y - y1;
                dot1 = dx * dx + dy * dy;
                distance = Math.sqrt(dot1);
                if (distance > 1)
                {
                    nx = dx / distance;
                    ny = dy / distance;
                }
                else
                {
                    nx = player.oldNx;
                    ny = player.oldNy;
                } // end else if
                vitesse = 0;
            } // end else if
        } // end else if
        nxa = nx;
        nya = ny;
        if (id == _curPlayer && player.poste == 0)
        {
            dx = _parent._xmouse - x1;
            dy = _parent._ymouse - y1;
            dot = dx * dx + dy * dy;
            dist = Math.sqrt(dot);
            if (dist > 0.010000)
            {
                nxa = dx / distance;
                nya = dy / distance;
            } // end if
        } // end if
        player.oldNx = nx;
        player.oldNy = ny;
        angle = Math.atan2(nxa, -nya);
        player.angle = angle;
        player.angleBallon = angle;
        degre = angle * 180 / 3.141593;
        player.degre = degre;
        ori = (Math.floor(degre / 45) + 4) % 8;
        if (player.poste == 0)
        {
            if (_xMField >= player.x)
            {
                side = 0;
                setProperty(eval(player.clipName), _xscale, 30);
                if (degre < 0)
                {
                    player.angleBallon = Math.atan2(-nxa, -nya);
                } // end if
            }
            else
            {
                side = 1;
                setProperty(eval(player.clipName), _xscale, -30);
                if (degre > 0)
                {
                    player.angleBallon = Math.atan2(-nxa, -nya);
                } // end if
            } // end else if
            ori = _goalAnimCorection[side ^ 1][ori];
        } // end if
        player.ori = ori;
        if (player.boost != 0)
        {
            vitesse = vitesse * 2;
            setProperty(eval(player.clipName).trainee, _rotation, degre);
            player.boostTimer = player.boostTimer - _nbMs;
            if (player.boostTimer <= 0)
            {
                player.boost = 0;
                setProperty(eval(player.clipName).trainee, _visible, false);
            } // end if
        } // end if
        if (id == _curPorteur)
        {
            vitesse = vitesse * 0.900000;
        } // end if
        if (player.bBrake == true)
        {
            player.bBrake = false;
            vitesse = vitesse * 0.500000;
        } // end if
        if (_curFaute == "but")
        {
            if (vitesse > 0)
            {
                vitesse = 100;
            } // end if
        }
        else if (_doFormation == true)
        {
            if (vitesse > 0)
            {
                vitesse = vitesse * 3;
                if (vitesse < 90)
                {
                    vitesse = 90;
                } // end if
            } // end if
        } // end else if
        if (vitesse > 0)
        {
            ++_arbitre.nbMovingPlayers;
        } // end if
        player.speed = vitesse;
        nx2 = nx * vitesse * _nbMs * 0.001000;
        ny2 = ny * vitesse * _nbMs * 0.001000;
        dot2 = nx2 * nx2 + ny2 * ny2;
        if (dot2 >= dot1)
        {
            x1 = x2;
            y1 = y2;
        }
        else
        {
            x1 = x1 + nx2;
            y1 = y1 + ny2;
        } // end else if
        player.x = x1;
        player.y = y1;
        animationPlayer(player, ori);
    } // End of the function
    function animationPlayer(player, ori)
    {
        var frame;
        var etiquette;
        player.timer = player.timer + _nbMs * 0.010000;
        player.timer = player.timer % player.animNbFrames;
        frame = player.frameIndex;
        frame = frame + ori * player.animNbFrames + Math.floor(player.timer);
        if (player.oldFrame == frame)
        {
            return;
        } // end if
        eval(player.clipName).mcMaillot.gotoAndStop(frame);
        eval(player.clipName).gotoAndStop(frame);
        player.oldFrame = frame;
    } // End of the function
    function playerArrete(player)
    {
        player.action = 0;
        player.timer = 0;
        player.animNbFrames = 1;
        if (player.poste == 0)
        {
            player.frameIndex = 25;
        }
        else
        {
            player.frameIndex = 65;
        } // end else if
    } // End of the function
    function playerDemare(player)
    {
        player.action = 2;
        player.timer = 0;
        if (player.poste == 0)
        {
            player.animNbFrames = 8;
            player.frameIndex = 1;
        }
        else
        {
            player.animNbFrames = 8;
            player.frameIndex = 1;
        } // end else if
    } // End of the function
    function playerTacle(player)
    {
        player.action = 4;
        player.tacleTimer = 500;
        player.tacleFirstFrame = true;
        player.tacleNx = Math.sin(player.angle);
        player.tacleNy = -Math.cos(player.angle);
        if (player.poste == 0)
        {
            player.animNbFrames = 1;
            player.frameIndex = 25;
        }
        else
        {
            player.animNbFrames = 6;
            player.frameIndex = 73;
        } // end else if
    } // End of the function
    function playerFx1(player, type)
    {
        player.action = 10;
        player.tacleTimer = 500;
        player.tacleFirstFrame = true;
        player.tacleNx = Math.sin(player.angle);
        player.tacleNy = -Math.cos(player.angle);
        if (player.poste != 0)
        {
            player.animNbFrames = 3;
            if (type == 1)
            {
                player.frameIndex = 197;
            }
            else
            {
                player.frameIndex = 173;
            } // end if
        } // end else if
        if (_sons == true)
        {
            sonFx1.start();
        } // end if
    } // End of the function
    function trigerTacle(player)
    {
        if (_curPorteur > 0)
        {
            if (_players[_curPorteur].godTimer > 0)
            {
                return;
            } // end if
        } // end if
        _sentTimer = 800;
        if (_sons == true)
        {
            sonTacle.start();
        } // end if
        if (player.id < 5)
        {
            impulseBall(player.angleBallon + (Math.random() - 0.500000) * 90, _teamTable[0].passeSpeed);
        }
        else
        {
            impulseBall(player.angleBallon + (Math.random() - 0.500000) * 90, _teamTable[1].passeSpeed);
        } // end else if
        playerTacle(player);
        _curSendeurFaute = player.id;
    } // End of the function
    function playerManageTacle(player)
    {
        player.tacleTimer = player.tacleTimer - _nbMs;
        if (player.tacleTimer <= 0 && player.tacleFirstFrame == false)
        {
            playerDemare(player);
            return;
        } // end if
        player.tacleFirstFrame = false;
    } // End of the function
    function teamSetFormation(teamNum, num, doFlipp, interFrame)
    {
        var i;
        var ptr;
        var side;
        var index;
        _doFormation = true;
        _parent.mcInteruption.interOn(_dispositionsTitles[num], interFrame);
        index = teamNum * 5;
        if (doFlipp != true)
        {
            bFlipp = 0;
        }
        else if (teamNum == 0)
        {
            bFlipp = _team1Side;
        }
        else
        {
            bFlipp = _team1Side ^ 1;
        } // end else if
        if (bFlipp == 0)
        {
            for (i = 0; i < 5; i++)
            {
                _players[index + i].xTarget = _xMField + _dispositions[num][i * 2 + 0];
                _players[index + i].yTarget = _yMField + _dispositions[num][i * 2 + 1];
            } // end of for
        }
        else
        {
            for (i = 0; i < 5; i++)
            {
                _players[index + i].xTarget = _xMField - _dispositions[num][i * 2 + 0];
                _players[index + i].yTarget = _yMField + _dispositions[num][i * 2 + 1];
            } // end of for
        } // end else if
    } // End of the function
    function teamFreeze()
    {
        var i;
        trace ("teamFreeze()");
        for (i = 0; i < 10; i++)
        {
            setProperty(eval(_players[i].clipName).cercle, _visible, false);
            setProperty(eval(_players[i].clipName).trainee, _visible, false);
            setProperty(eval(_players[i].btName), _visible, false);
        } // end of for
    } // End of the function
    function teamUnFreeze()
    {
        var i;
        trace ("teamUnFreeze()");
        for (i = 0; i < 5; i++)
        {
            if (i == _curPlayer)
            {
                eval(_players[i].clipName).cercle._visible = true;
            }
            else
            {
                eval(_players[i].clipName).cercle._visible = false;
            } // end else if
            if (i == _curPorteur)
            {
                eval(_players[i].btName)._visible = false;
            }
            else
            {
                eval(_players[i].btName)._visible = true;
            } // end else if
            eval(_players[i].clipName).trainee._visible = false;
        } // end of for
        for (i = 5; i < 10; i++)
        {
            eval(_players[i].clipName).cercle._visible = false;
            if (i == _curPorteur)
            {
                eval(_players[i].btName)._visible = true;
            }
            else
            {
                eval(_players[i].btName)._visible = false;
            } // end else if
            eval(_players[i].clipName).trainee._visible = false;
        } // end of for
    } // End of the function
    function ManageGame()
    {
        var player;
        if (_stopRequest == 3)
        {
            _stopRequest = 0;
            _parent.btStart._visible = true;
            _parent.btStart.gotoAndStop(1);
            _parent.mcInfo.btQuit._visible = true;
            return;
        } // end if
        if (_stopRequest == 2)
        {
            pushQualite();
            _parent.gotoAndStop("exit");
            return;
        } // end if
        if (_stopRequest == 1)
        {
            _stopRequest = 0;
            _state = "exit";
            _doFormation = true;
            teamFreeze();
            _arbitre.action = "play";
            ballPut(_xMField, _yMField);
            _parent.mcPause.interOff();
            _parent.mcPan.paneauOff();
            arbitreCompteurHide();
            return;
        } // end if
        if (Key.isDown(83))
        {
            if (_sonKeyState != true)
            {
                _parent.mcMusic.switchMusic();
                _sonKeyState = true;
            } // end if
        }
        else
        {
            _sonKeyState = false;
        } // end else if
        if (_state == "pause")
        {
            if (Key.isDown(80))
            {
                if (_pauseKeyState != true)
                {
                    unpauseGame();
                    _pauseKeyState = true;
                } // end if
            }
            else
            {
                _pauseKeyState = false;
            } // end else if
            return;
        } // end if
        if (_state != "replay")
        {
            manageArbitre();
        } // end if
        if (_state == "undef")
        {
            initGame();
            initBall();
            initAI();
            initArbitre();
            initRecord();
            initBonus();
            initSounds();
            trigerWaitStart(false);
            _parent.mcMusic.switchMusicOn();
        }
        else if (_state == "waitStart")
        {
            manageBall1();
            managePlayers();
            manageBall2();
        }
        else if (_state == "play")
        {
            manageSonStade();
            if (Key.isDown(80))
            {
                if (_pauseKeyState != true)
                {
                    _pauseKeyState = true;
                    pauseGame();
                } // end if
            }
            else
            {
                _pauseKeyState = false;
            } // end else if
            if (chronoManage() == true)
            {
                if (_arbitre.action == "play")
                {
                    gameHalfTime();
                } // end if
            } // end if
            manageBall1();
            manageAi();
            managePlayers();
            manageBall2();
            manageBonus();
            recordGame();
        }
        else if (_state == "replay")
        {
            manageReplay();
        }
        else if (_state == "miTemps")
        {
            _parent.mcSonStade.volumeSon(0, pan);
        }
        else if (_state == "finPartie")
        {
            _parent.mcSonStade.volumeSon(0, pan);
        }
        else if (_state == "waitScore")
        {
            _parent.mcSonStade.volumeSon(0, pan);
            scoreWait();
        }
        else if (_state == "exit")
        {
            _parent.mcSonStade.volumeSon(0, pan);
            trigerWaitStart(true);
        }
        else if (_state == "exitReload")
        {
            _parent.mcSonStade.volumeSon(0, pan);
            trigerWaitStart(false);
        } // end else if
    } // End of the function
    function trigerMiseEnJeu(team, time)
    {
        var relanceur;
        trace ("remise en jeu equipe " + team);
        _state = "play";
        if (Math.random() < 0.500000)
        {
            relanceur = 0;
        }
        else
        {
            relanceur = 1;
        } // end else if
        if (team == 0)
        {
            arbitreTrigerFaute("miseEnJeu", time, 3 + relanceur, 3 + (relanceur ^ 1), true, _teamTable[0].passeSpeed * 0.500000, false);
        }
        else
        {
            arbitreTrigerFaute("miseEnJeu", time, 8 + relanceur, 8 + (relanceur ^ 1), true, _teamTable[1].passeSpeed * 0.500000, false);
        } // end else if
        _aiBank = 0;
        _aiRefreshTimer = 0;
        ballPut(_xMField, _yMField);
        num = 1 + team;
        numForm = 6 + _teamTable[0].form;
        if (num == 2)
        {
            num = numForm;
        }
        else
        {
            for (i = 2; i < 6; i++)
            {
                _dispositions[1][i] = _dispositions[numForm][i];
            } // end of for
        } // end else if
        teamSetFormation(0, num, true, 1);
        num = 1 + (team ^ 1);
        numForm = 6 + _teamTable[0].form;
        if (num == 2)
        {
            num = numForm;
        }
        else
        {
            for (i = 2; i < 6; i++)
            {
                _dispositions[1][i] = _dispositions[numForm][i];
            } // end of for
        } // end else if
        teamSetFormation(1, num, true, 1);
    } // End of the function
    function trigerGoal(side)
    {
        var team;
        var bOk;
        if (_sons == true)
        {
            sonHourra.start();
        } // end if
        _doFormation = true;
        arbitreTrigerFaute("but", 4200, -1, -1, false, 1, true);
        bOk = true;
        if (side == _team1Side)
        {
            team = 0;
            if (_curSendeur >= 0 || _curSendeur < 5)
            {
                bOk = false;
            } // end if
        }
        else
        {
            team = 1;
            if (_curSendeur >= 5)
            {
                bOk = false;
            } // end if
        } // end else if
        trace ("but de team" + team);
        trace ("but de" + _curSendeur);
        _goaledTeam = team;
        _teamTable[team ^ 1].score = _teamTable[team ^ 1].score + 1;
        if (_teamTable[0].score < _teamTable[1].score)
        {
            _handicapedTeam = 1;
        }
        else if (_teamTable[1].score < _teamTable[0].score)
        {
            _handicapedTeam = 0;
        }
        else
        {
            _handicapedTeam = -1;
        } // end else if
        refreshPods();
        ballPut(275, 150);
        setCurMaillotColor(team ^ 1);
        _parent.mcInteruption.interOn("But !!!", 1);
        if (bOk == true)
        {
            _parent.mcCinematic.animePlay();
        } // end if
        _bTrigerReplay = true;
    } // End of the function
    function arbitreTrigerFaute(title, duree, relanceur, receveur, automatic, relanceSpeed, bSifflet)
    {
        var team;
        if (bSifflet == true)
        {
            if (_sons == true)
            {
                sonSifflet.start();
            } // end if
            _extraTime = 3000;
        } // end if
        _arbitre.action = "faute";
        _curFaute = title;
        _arbitre.timer = duree;
        _curRelanceur = relanceur;
        _arbitre.bRelanceAuto = automatic;
        _relanceSpeed = relanceSpeed;
        ballNewPorteur(-1);
        if (_curRelanceur >= 0 && _curRelanceur < 5)
        {
            team = 0;
            _freezePChange = true;
            selectPlayer(_curRelanceur);
        }
        else
        {
            team = 1;
        } // end else if
        if (receveur < 0)
        {
            _curReceveur = int(Math.random() * 4 + (1 + team * 5));
        }
        else
        {
            _curReceveur = receveur;
        } // end else if
        tacticRefreshAi();
    } // End of the function
    function trigerCorner(side, upDwn)
    {
        var corner;
        if (side != _team1Side)
        {
            _teamTable[0].statCorners = _teamTable[0].statCorners + 1;
            arbitreTrigerFaute("corner", 1000, 2, 4, false, _teamTable[0].passeSpeed * 0.800000, true);
        }
        else
        {
            _teamTable[1].statCorners = _teamTable[1].statCorners + 1;
            arbitreTrigerFaute("corner", 1000, 7, 9, false, _teamTable[1].passeSpeed * 0.800000, true);
        } // end else if
        corner = side * 2 + upDwn;
        if (side != _team1Side)
        {
            teamGenerateCornerFormationAttaque(0, corner, _team1Side);
            teamGenerateCornerFormationDefence(1, corner, _team1Side ^ 1);
        }
        else
        {
            teamGenerateCornerFormationAttaque(1, corner, _team1Side ^ 1);
            teamGenerateCornerFormationDefence(0, corner, _team1Side);
        } // end else if
    } // End of the function
    function teamGenerateCornerFormationAttaque(teamNum, coin, teamSide)
    {
        var i;
        var j;
        var x;
        var y;
        var sx;
        var sy;
        var xp;
        var yp;
        var dx;
        var dy;
        var dist;
        var security;
        sx = _cornerTable[coin].sx;
        sy = _cornerTable[coin].sy;
        xp = _xMField - _dxField * 0.500000 * sx;
        yp = _yMField - _dyField * 0.500000 * sy;
        ballPut(xp + 5 * sx, yp + 5 * sy);
        for (i = 1; i < 5; i++)
        {
            if (i == _curRelanceur % 5)
            {
                continue;
            } // end if
            if (i < 3)
            {
                _dispositions[3][i * 2 + 0] = -_teamTable[teamNum].signeDir * Math.random() * 20;
                _dispositions[3][i * 2 + 1] = (Math.random() - 0.500000) * 40;
                continue;
            } // end if
            if (i == 3)
            {
                _dispositions[3][i * 2 + 0] = _teamTable[teamNum].signeDir * 140;
                _dispositions[3][i * 2 + 1] = 0;
                continue;
            } // end if
            security = 0;
            do
            {
                x = xp - _xMField + (30 + Math.random() * 100) * sx;
                y = yp - _yMField + (60 + Math.random() * 100) * sy;
                for (j = 1; j < i; j++)
                {
                    if (j == _curRelanceur % 5)
                    {
                        continue;
                    } // end if
                    dx = _dispositions[3][j * 2 + 0] - x;
                    dy = _dispositions[3][j * 2 + 1] - y;
                    dist = dx * dx + dy * dy;
                    if (dist < _placementMinDist)
                    {
                        break;
                    } // end if
                } // end of for
                ++security;
            } while (dist < _placementMinDist && security < _securityLimit)
            _dispositions[3][i * 2 + 0] = x;
            _dispositions[3][i * 2 + 1] = y;
        } // end of for
        if (teamSide == 0)
        {
            _dispositions[3][0] = -195;
        }
        else
        {
            _dispositions[3][0] = 195;
        } // end else if
        _dispositions[3][1] = 0;
        _dispositions[3][_curRelanceur % 5 * 2 + 0] = xp - _xMField;
        _dispositions[3][_curRelanceur % 5 * 2 + 1] = yp - _yMField;
        teamSetFormation(teamNum, 3, false, 2);
    } // End of the function
    function teamGenerateCornerFormationDefence(teamNum, coin, teamSide)
    {
        var i;
        var j;
        var x;
        var y;
        var sx;
        var sy;
        var xp;
        var yp;
        var dx;
        var dy;
        var dist;
        var security;
        sx = _cornerTable[coin].sx;
        sy = _cornerTable[coin].sy;
        xp = _xMField - _dxField * 0.500000 * sx;
        yp = _yMField - _dyField * 0.500000 * sy;
        for (i = 1; i < 5; i++)
        {
            if (i < 3)
            {
                if (teamSide == 0)
                {
                    _dispositions[3][i * 2 + 0] = _dispositions[6][i * 2 + 0];
                }
                else
                {
                    _dispositions[3][i * 2 + 0] = -_dispositions[6][i * 2 + 0];
                } // end else if
                _dispositions[3][i * 2 + 1] = _dispositions[6][i * 2 + 1];
                continue;
            } // end if
            Q = Math.random() - 0.500000;
            if (Math.abs(Q) < 0.300000)
            {
                if (Q < 0)
                {
                    Q = -0.300000;
                }
                else
                {
                    Q = 0.300000;
                } // end if
            } // end else if
            _dispositions[3][i * 2 + 0] = _dispositions[3][i * 2 + 0] + Q * 80;
            _dispositions[3][i * 2 + 1] = _dispositions[3][i * 2 + 1] + (Math.random() - 0.500000) * 80;
        } // end of for
        if (teamSide == 0)
        {
            _dispositions[3][0] = -195;
        }
        else
        {
            _dispositions[3][0] = 195;
        } // end else if
        _dispositions[3][1] = 0;
        teamSetFormation(teamNum, 3, false, 2);
    } // End of the function
    function trigerRelanceGoal(side)
    {
        if (side == _team1Side)
        {
            arbitreTrigerFaute("relanceGoal", 1000, 0, 4, false, _teamTable[0].passeSpeed, true);
        }
        else
        {
            arbitreTrigerFaute("relanceGoal", 1000, 5, 9, false, _teamTable[1].passeSpeed, true);
        } // end else if
        trace ("Sortie de but pour joeur " + _curRelanceur);
        if (side == _team1Side)
        {
            teamGenerateRelanceFormationAttaque(0, side, _team1Side);
            teamGenerateRelanceFormationDefence(1, side, _team1Side ^ 1);
        }
        else
        {
            teamGenerateRelanceFormationAttaque(1, side, _team1Side ^ 1);
            teamGenerateRelanceFormationDefence(0, side, _team1Side);
        } // end else if
    } // End of the function
    function teamGenerateRelanceFormationAttaque(teamNum, side, teamSide)
    {
        var i;
        var x;
        var y;
        var sx;
        var x0;
        var xp;
        var yp;
        if (side == 0)
        {
            sx = 1;
        }
        else
        {
            sx = -1;
        } // end else if
        xp = _xMField - _dxField * 0.400000 * sx;
        yp = _yMField;
        x0 = xp + 15 * sx;
        ballPut(x0, yp);
        for (i = 1; i < 5; i++)
        {
            if (i < 3)
            {
                if (teamSide == 0)
                {
                    _dispositions[5][i * 2 + 0] = Math.random() * 40 * _teamTable[teamNum].signeDir + _dispositions[6][i * 2 + 0];
                }
                else
                {
                    _dispositions[5][i * 2 + 0] = Math.random() * 40 * _teamTable[teamNum].signeDir - _dispositions[6][i * 2 + 0];
                } // end else if
                _dispositions[5][i * 2 + 1] = _dispositions[6][i * 2 + 1];
                continue;
            } // end if
            x = (70 + Math.random() * 50) * sx - (xp - _xMField);
            y = _dispositions[6][i * 2 + 1] + (Math.random() - 0.500000) * 40;
            _dispositions[5][i * 2 + 0] = xp - _xMField + x;
            _dispositions[5][i * 2 + 1] = yp - _yMField + y;
        } // end of for
        _dispositions[5][0] = xp - _xMField;
        _dispositions[5][1] = 0;
        teamSetFormation(teamNum, 5, false, 1);
    } // End of the function
    function teamGenerateRelanceFormationDefence(teamNum, side, teamSide)
    {
        var i;
        var x;
        var y;
        var sx;
        var x0;
        var xp;
        var yp;
        if (side == 0)
        {
            sx = 1;
        }
        else
        {
            sx = -1;
        } // end else if
        xp = _xMField - _dxField * 0.400000 * sx;
        yp = _yMField;
        for (i = 1; i < 5; i++)
        {
            if (i < 3)
            {
                if (teamSide == 0)
                {
                    _dispositions[5][i * 2 + 0] = _dispositions[6][i * 2 + 0];
                }
                else
                {
                    _dispositions[5][i * 2 + 0] = -_dispositions[6][i * 2 + 0];
                } // end else if
                _dispositions[5][i * 2 + 1] = _dispositions[6][i * 2 + 1];
                continue;
            } // end if
            x = -(50 + Math.random() * 30) * sx - (xp - _xMField);
            y = _dispositions[6][i * 2 + 1] + (Math.random() - 0.500000) * 40;
            _dispositions[5][i * 2 + 0] = xp - _xMField + x;
            _dispositions[5][i * 2 + 1] = yp - _yMField + y;
        } // end of for
        if (side == 0)
        {
            _dispositions[5][0] = 195;
        }
        else
        {
            _dispositions[5][0] = -195;
        } // end else if
        _dispositions[5][1] = 0;
        teamSetFormation(teamNum, 5, false, 1);
    } // End of the function
    function trigerTouche(sender, upDwn)
    {
        if (sender < 5)
        {
            arbitreTrigerFaute("touche", 1000, 7, 9, false, _teamTable[1].passeSpeed, true);
            teamGenerateToucheFormationAttaque(1, upDwn, _team1Side ^ 1);
            teamGenerateToucheFormationDefence(0, upDwn, _team1Side);
        }
        else
        {
            arbitreTrigerFaute("touche", 1000, 2, 4, false, _teamTable[0].passeSpeed, true);
            teamGenerateToucheFormationAttaque(0, upDwn, _team1Side);
            teamGenerateToucheFormationDefence(1, upDwn, _team1Side ^ 1);
        } // end else if
        trace ("Touche pour le joueur: " + _curRelanceur);
    } // End of the function
    function teamGenerateToucheFormationAttaque(teamNum, upDwn, teamSide)
    {
        var i;
        var j;
        var x;
        var y;
        var xp;
        var yp;
        var y0;
        var sy;
        var dx;
        var dy;
        var dist;
        var security;
        if (upDwn == 0)
        {
            sy = 1;
        }
        else
        {
            sy = -1;
        } // end else if
        xp = _leBallon.x;
        if (xp < _x1Field + 15)
        {
            xp = _x1Field + 15;
        }
        else if (_x2Field - 15 < xp)
        {
            xp = _x2Field - 15;
        } // end else if
        yp = _yMField - _dyField * 0.500000 * sy;
        y0 = yp + 5 * sy;
        ballPut(xp, y0);
        for (i = 1; i < 5; i++)
        {
            if (i < 3)
            {
                if (teamSide == 0)
                {
                    _dispositions[4][i * 2 + 0] = _dispositions[6][i * 2 + 0];
                }
                else
                {
                    _dispositions[4][i * 2 + 0] = -_dispositions[6][i * 2 + 0];
                } // end else if
                _dispositions[4][i * 2 + 1] = _dispositions[6][i * 2 + 1];
                continue;
            } // end if
            security = 0;
            do
            {
                x = xp - _xMField + Math.random() * 50 * _teamTable[teamNum].signeDir;
                y = yp - _yMField + (50 + Math.random() * 100) * sy;
                for (j = 1; j < i; j++)
                {
                    dx = _dispositions[4][j * 2 + 0] - x;
                    dy = _dispositions[4][j * 2 + 1] - y;
                    dist = dx * dx + dy * dy;
                    if (dist < _placementMinDist)
                    {
                        break;
                    } // end if
                } // end of for
                ++security;
            } while (dist < _placementMinDist && security < _securityLimit)
            if (x < _x1Field + 50 - _xMField)
            {
                x = x + 50;
            }
            else if (_x2Field - 50 - _xMField < x)
            {
                x = x - 50;
            } // end else if
            _dispositions[4][i * 2 + 0] = x;
            _dispositions[4][i * 2 + 1] = y;
        } // end of for
        if (teamSide == 0)
        {
            _dispositions[4][0] = -195;
        }
        else
        {
            _dispositions[4][0] = 195;
        } // end else if
        _dispositions[4][1] = 0;
        _dispositions[4][_curRelanceur % 5 * 2 + 0] = xp - _xMField;
        _dispositions[4][_curRelanceur % 5 * 2 + 1] = yp - _yMField;
        teamSetFormation(teamNum, 4, false, 2);
    } // End of the function
    function teamGenerateToucheFormationDefence(teamNum, upDwn, teamSide)
    {
        var i;
        var x;
        var y;
        var xp;
        var yp;
        if (upDwn == 0)
        {
            sy = 1;
        }
        else
        {
            sy = -1;
        } // end else if
        xp = _leBallon.x;
        if (xp < _x1Field + 15)
        {
            xp = _x1Field + 15;
        }
        else if (_x2Field - 15 < xp)
        {
            xp = _x2Field - 15;
        } // end else if
        yp = _yMField - _dyField * 0.500000 * sy;
        for (i = 1; i < 5; i++)
        {
            if (i < 3)
            {
                if (teamSide == 0)
                {
                    _dispositions[4][i * 2 + 0] = _dispositions[6][i * 2 + 0];
                }
                else
                {
                    _dispositions[4][i * 2 + 0] = -_dispositions[6][i * 2 + 0];
                } // end else if
                _dispositions[4][i * 2 + 1] = _dispositions[6][i * 2 + 1];
                continue;
            } // end if
            security = 0;
            do
            {
                Q = Math.random() - 0.500000;
                if (Math.abs(Q) < 0.300000)
                {
                    if (Q < 0)
                    {
                        Q = -0.300000;
                    }
                    else
                    {
                        Q = 0.300000;
                    } // end if
                } // end else if
                x = _dispositions[4][i * 2 + 0] + Q * 80;
                y = _dispositions[4][i * 2 + 1] + (Math.random() - 0.500000) * 80;
                for (j = 1; j < i; j++)
                {
                    dx = _dispositions[4][j * 2 + 0] - x;
                    dy = _dispositions[4][j * 2 + 1] - y;
                    dist = dx * dx + dy * dy;
                    if (dist < _placementMinDist)
                    {
                        break;
                    } // end if
                } // end of for
                ++security;
            } while (dist < _placementMinDist && security < _securityLimit)
            _dispositions[4][i * 2 + 0] = x;
            _dispositions[4][i * 2 + 1] = y;
        } // end of for
        if (teamSide == 0)
        {
            _dispositions[4][0] = -195;
        }
        else
        {
            _dispositions[4][0] = 195;
        } // end else if
        _dispositions[4][1] = 0;
        teamSetFormation(teamNum, 4, false, 2);
    } // End of the function
    function trigerWaitStart(bFlag)
    {
        var i;
        _state = "waitStart";
        chronoReset();
        teamFreeze();
        teamSetFormation(0, 0, true, 1);
        teamSetFormation(1, 0, true, 1);
        for (i = 0; i < 2; i++)
        {
            _teamTable[i].score = 0;
            _teamTable[i].statTirs = 0;
            _teamTable[i].statCorners = 0;
            _teamTable[i].statPossession = 0;
        } // end of for
        _handicapedTeam = -1;
        refreshPods();
        _parent.mcInfo.mcPause._visible = false;
        _parent.btStart._visible = true;
        _parent.mcInteruption.interOff();
        _parent.mcSonStade.volumeSon(0);
        _parent.mcField.refreshField(-1);
        if (bFlag == true)
        {
            pushQualite();
            _parent.gotoAndStop("exit");
        }
        else
        {
            _parent.btStart.gotoAndStop(1);
        } // end else if
    } // End of the function
    function trigerStart()
    {
        _parent.mcMusic.musicPlay();
        _parent.mcInfo.btQuit._visible = true;
        _parent.btStart._visible = false;
        _parent.mcInfo.mcPause._visible = true;
        chronoReset();
        teamUnFreeze();
        selectPlayer(3);
        _half = 0;
        _starter = 0;
        _starter = int(Math.random() * 2) & 1;
        _team1Side = 0;
        _parent.mcInteruption.interOff();
        newSeedAi();
        trigerMiseEnJeu(_starter, 500);
        pushQualite();
        _parent.mcField.refreshField(_team1Side);
        _parent.mcPod.refreshHalfTime(_half);
        _recordCurDepth = 0;
    } // End of the function
    function trigerExit()
    {
        _parent.mcInfo.btQuit._visible = false;
        if (_state == "waitStart")
        {
            _stopRequest = 2;
        }
        else if (_state != "undef" && _state != "exit")
        {
            _stopRequest = 1;
            _parent.mcCinematic.animeStop();
        } // end else if
        trigerEndReplay();
    } // End of the function
    function trigerFinMiTempsFinPartie()
    {
        if (_state == "miTemps")
        {
            chronoReset();
            _state = "play";
            selectPlayer(3);
            _starter = _starter ^ 1;
            _team1Side = _team1Side ^ 1;
            trigerMiseEnJeu(_starter, 500);
            newSeedAi();
            _parent.mcField.refreshField(_team1Side);
        }
        else if (_state == "finPartie")
        {
            _state = "exitReload";
        } // end else if
        _parent.mcPod.refreshHalfTime(_half);
        _recordCurDepth = 0;
    } // End of the function
    function gameHalfTime()
    {
        endBonus();
        if (_half == 0)
        {
            _half = 1;
            _state = "miTemps";
            if (_sons == true)
            {
                sonSifflet.start();
            } // end if
            _parent.mcPan.paneauOn(1, _teamTable[0], _teamTable[1], true);
        }
        else if (_half == 1)
        {
            _level0.mcCom3.vars.score_cpu = _teamTable[1].score;
            _level0.mcCom3.vars.score_joueur = _teamTable[0].score;
            _level0.mcCom3.sendScore();
            _half = 2;
            _state = "waitScore";
            _scoreWaitStep = 0;
            teamFreeze();
            ballPut(275, 150);
            if (_sons == true)
            {
                sonSifflet.start();
            } // end if
            if (_sons == true && _teamTable[1].score < _teamTable[0].score)
            {
                sonHourra.start();
            } // end if
            _parent.mcPan.paneauOn(2, _teamTable[0], _teamTable[1], true);
        } // end else if
        _parent.mcRay.hideRay();
        _parent.mcInteruption.interOff();
        _parent.mcField.refreshField(-1);
    } // End of the function
    function scoreWait()
    {
        if (_scoreWaitStep == 0)
        {
            if (_level0.mcCom3._waitReception == "done")
            {
                _state = "finPartie";
                if (_level0.mcCom3._state == "ok")
                {
                    frame = 3;
                    _parent.mcPan.paneauOnEx(frame, _teamTable[0], _teamTable[1], false);
                }
                else
                {
                    frame = 4;
                    _parent.mcPan.paneauOn(frame, _teamTable[0], _teamTable[1], false);
                } // end else if
                _scoreWaitStep = 1;
            } // end if
        } // end if
    } // End of the function
    function clicTerrain()
    {
        if (_state != "play")
        {
            if (_state == "replay")
            {
                trigerEndReplay();
            } // end if
            return;
        } // end if
        if (_curPlayer < 0)
        {
            return;
        } // end if
        if (_players[_curPlayer].action != 0)
        {
            playerBoost(_players[_curPlayer]);
        } // end if
    } // End of the function
    function rollOverFootballeur(nom)
    {
        var num;
        if (_state != "play")
        {
            return;
        } // end if
        num = nom.charAt(6);
        if (num == 0 || num >= 5)
        {
            return;
        } // end if
        if (num == _curPlayer)
        {
            return;
        } // end if
        if (_bAutoSelection == true)
        {
            if (_teamTable[0].mode != "goto goal")
            {
                selectPlayer(num);
            } // end if
        } // end if
        if (_curRelanceur >= 0)
        {
            if (_curRelanceur < 5)
            {
                _curReceveur = num;
                _parent.mcRay.setRayTarget(_players[num].x, _players[num].y);
            } // end if
        }
        else if (_arbitre.action == "play")
        {
            _players[num].pause = _bStopOver;
        } // end else if
    } // End of the function
    function clicFootballeur(nom)
    {
        var num;
        var player1;
        var player2;
        if (_state != "play")
        {
            return;
        } // end if
        num = nom.charAt(6);
        if (_arbitre.action == "waitShoot" || _curRelanceur >= 0 && _curRelanceur < 5)
        {
            if (_arbitre.bRelanceAuto == true)
            {
                return;
            } // end if
            if (_arbitre.relanceDone == false && _curRelanceur < 5)
            {
                if (num > 0 && num < 5)
                {
                    player2 = _players[num];
                    ballPasse(player2, _relanceSpeed, 0);
                    _arbitre.relanceDone = true;
                    _curSendeur = _curPlayer;
                    _curSendeurFaute = _curPlayer;
                    selectPlayer(num);
                } // end if
            } // end if
            return;
        } // end if
        if (num < 5)
        {
            if (_curPorteur == _curPlayer)
            {
                if (num == 0)
                {
                    if (_sons == true)
                    {
                        sonBuzzer.start();
                    } // end if
                    return;
                } // end if
                ballPasse(_players[num], _teamTable[0].passeSpeed, 0);
            } // end if
            if (num == 0)
            {
                if (_sons == true)
                {
                    sonBuzzer.start();
                } // end if
                return;
            } // end if
            selectPlayer(num);
        }
        else if (_curRelanceur < 0)
        {
            if (_curPorteur > 5 && _curPorteur == num)
            {
                player1 = _players[_curPlayer];
                if (_player1.action != 4)
                {
                    player2 = _players[num];
                    if (inRange(player1.x, player1.y, player2.x, player2.y, 20) == true)
                    {
                        trigerTacle(player1);
                    } // end if
                } // end if
            } // end if
        } // end else if
    } // End of the function
    function pressBut(cote)
    {
        var player;
        if (_state != "play")
        {
            return;
        } // end if
        if (_curPorteur < 0)
        {
            dx = _xMField - _leBallon.x;
            if (dx * _teamTable[0].signeDir <= 0)
            {
                _bReprise = true;
                _bRepriseX = _parent._xmouse;
                _bRepriseY = _parent._ymouse;
            } // end if
        } // end if
        if (_curPlayer == _curPorteur && _curPlayer < 5 && _curRelanceur < 0)
        {
            if (_curPlayer == 0)
            {
                if (_sons == true)
                {
                    sonBuzzer.start();
                } // end if
            }
            else
            {
                _butPlayer = _curPlayer;
                player = _players[_curPlayer];
                eval("_parent.mcPower" + (_team1Side ^ 1)).startAccumulation();
            } // end if
        } // end else if
    } // End of the function
    function releaseBut(cote)
    {
        var power;
        var player;
        _bReprise = false;
        if (_butPlayer != _curPlayer)
        {
            return;
        } // end if
        if (_butPlayer < 5)
        {
            power = eval("_parent.mcPower" + (_team1Side ^ 1))._power;
        }
        else
        {
            power = eval("_parent.mcPower" + _team1Side)._power;
        } // end else if
        if (power > 18)
        {
            _probaBlocShoot = 0;
        }
        else if (power > 10)
        {
            _probaBlocShoot = 0.250000;
        }
        else
        {
            _probaBlocShoot = 0.500000;
        } // end else if
        player = _players[_butPlayer];
        player.pause = false;
        shootSpeed = _teamTable[0].shootSpeed + _teamTable[0].shootSpeed * power * _powerQ;
        ballShootGoal(player, _parent._xmouse, _parent._ymouse, shootSpeed);
        _butPlayer = -1;
    } // End of the function
    var _debug;
    var _version;
    var _nbMs;
    var _oldTime;
    var _bank;
    var _chrono;
    var _frameOverflow;
    var _securityLimit;
    var _placementMinDist;
    var _scoreWaitStep;
    var _sons;
    var _state;
    var _oldQualite;
    var _half;
    var _starter;
    var _stopRequest;
    var _gameDuration;
    var _team1Side;
    var _aiRefreshTimer;
    var _arbitre;
    var _players;
    var _leBallon;
    var _teamTable;
    var _playerIds;
    var _curPlayer;
    var _curPorteur;
    var _curSendeur;
    var _curSendeurFaute;
    var _curRelanceur;
    var _curReceveur;
    var _butPlayer;
    var _curMarquage;
    var _bKeepBallTraj;
    var _passCosTrash;
    var _powerQ;
    var _y0Buts;
    var _y1Buts;
    var _y2Buts;
    var _y3Buts;
    var _x1Field;
    var _x2Field;
    var _y1Field;
    var _y2Field;
    var _xMField;
    var _yMField;
    var _dxField;
    var _dyField;
    var _xGoalTarget;
    var _yGoalTarget;
    var _passeTargetId;
    var _btVisible;
    var _bStopOver;
    var _probaBlocShoot;
    var _curFaute;
    var _pauseKeyState;
    var _bReprise;
    var _bRepriseX;
    var _bRepriseY;
    var _catchRayon;
    var _goalCanBoost;
    var _doFormation;
    var _bShootDirect;
    var _relanceSpeed;
    var _extraTime;
    var _sentTimer;
    var _freezePChange;
    var _goaledTeam;
    var _handicapedTeam;
    var _ctrlRange;
    var _bAutoSelection;
    var _probaTimerLimit;
    var _maillotColor;
    var _maillotColors;
    var _clocheTable;
    var _sortedList1;
    var _sortedList2;
    var _playerSortTable;
    var _passeProbaTable1;
    var _passeProbaTable2;
    var _goalAnimCorection;
    var _dispositions;
    var _dispositionsTitles;
    var _cornerTable;
    var _comportTable;
    var _attaqueFlags;
    var _playerPasseTable;
    var _recordPtr;
    var _recordCurDepth;
    var _recordDepth;
    var _recordBallList;
    var _recordPlayerList;
    var _repStartTime;
    var _recordDecomp;
    var _doBonus;
    var _bonusState;
    var _bonusTimer;
    var _xBonus;
    var _yBonus;
    var _team1Form;
    var _teamFormTable;
    _version = "version 1.1";
    switchSelMode1();
    switchSonOn();
    _debug = false;
    _pauseKeyState = true;
    _oldQualite = _parent._quality;
    _parent.deb1 = "";
    _playerIds = ["gardien", "joueur", "joueur", "joueur", "joueur", "gardien", "joueur", "joueur", "joueur", "joueur"];
    if (_debug == true)
    {
        _playerIds = ["gardienDeb", "joueurDeb", "joueurDeb", "joueurDeb", "joueurDeb", "gardienDeb", "joueurDeb", "joueurDeb", "joueurDeb", "joueurDeb"];
    } // end if
    _teamFormTable = ["Classique", "Offensive", "Défensive"];
    _passCosTrash = 0.766044;
    _securityLimit = 20;
    _placementMinDist = 3600;
    _cornerTable = new Array();
    _cornerTable[0] = {sx: 1, sy: 1};
    _cornerTable[1] = {sx: 1, sy: -1};
    _cornerTable[2] = {sx: -1, sy: 1};
    _cornerTable[3] = {sx: -1, sy: -1};
    _curPlayer = -1;
    _stopRequest = 0;
    _state = "undef";
    _goalAnimCorection = new Array();
    _goalAnimCorection[0] = [2, 1, 1, 0, 0, 0, 2, 2];
    _goalAnimCorection[1] = [2, 2, 0, 0, 0, 1, 1, 2];
    _frameOverflow = 0;
    _oldTime = getTimer();
}
onClipEvent (unload)
{
    stopAllSounds ();
}
onClipEvent (enterFrame)
{
    Synchro();
    ManageGame();
}
